Attribute VB_Name = "modCodici"
'=======================================================================================
' Descrizione.....: Variabili e codici per l' invio, l' acquisizione
'                   e la decodifica di toni audio.
' Nome dei Files..: modCodici.bas
' Data............: 19/03/2004 (Ver. 1.0)
' Versione........: 1.0 a 32 bits.
' Sistema.........: VB6 (SP5) sotto Windows XP (SP2).
' Scritto da......: F. Languasco 
' E-Mail..........: MC7061@mclink.it
' DownLoads a.....: http://www.flanguasco.org
'=======================================================================================
'
Option Explicit
'
' Parametri del codice tonale:
Public Codice$              ' Nome del codice da usare.
Public MinToneWidth#        ' [s].
Public MaxToneWidth#        ' [s].
Public ToneWidth#           ' [s].
Public MinInToneGap#        ' [s].
Public MaxInToneGap#        ' [s].
Public InToneGap#           ' [s].
Public MaxTonesRX&          ' N massimo di toni nella sequenza in ricezione;
                            ' in questa versione serve solo a determinare la
                            ' lunghezza dei buffers di acquisizione.
'
Public NFreq&               ' N di frequenze nella tabella.
Private NTones&             ' N di toni nella tabella.
Private NTonesDec&          ' N di toni decodificabili.
Public ToneChar$()          ' Vettore dei caratteri associati ai toni.
Public ToneFreq#()          ' Vettore delle frequenze dei toni [Hz].
Private IToneFreq1&()       ' Vettore degli indici della prima   frequenza dei toni [Hz].
Private IToneFreq2&()       ' Vettore degli indici della seconda frequenza dei toni [Hz].
Public TabDTMF$()           ' Tabella delle corrispondenze indici di frequenza / carattere.
Public DeltaFreq#()         ' Vettore dei limiti min. e Max. delle frequenze [Hz].
                            '  DeltaFreq(1, I) e' il valor minimo ammesso per la frequenza I.
                            '  DeltaFreq(2, I) e' il valor massimo ammesso per la frequenza I.
                            ' Usato solo per le impostazioni del filtro.
'
Public TnFMin#              ' Minima frequenza nella tabella dei toni [Hz].
Public TnFMax#              ' Massima frequenza nella tabella dei toni [Hz].
                            ' Queste frequenze comprendono la tolleranza.
'
Public Type ToneTab_Type
    TnFMin As Double            ' Minima frequenza nella tabella dei toni [Hz].
    TnFMax As Double            ' Massima frequenza nella tabella dei toni [Hz].
    NTones As Long              ' N di toni nella tabella.
    NTonesDec As Long           ' N di toni decodificabili.
    Char() As String            ' Caratteri associati ai toni.
    Freq() As Double            ' Frequenze dei toni [Hz].
    DeltaFreq() As Double       ' Vettore dei limiti min. e Max. delle frequenze [Hz].
End Type
Public ToneTab As ToneTab_Type  ' Non usato, in questa versione.
'
' Corrispondenze Sequenze -> Testi:
Private Type SeqTxt_Type        '
    Sequenza As String          '
    Testo As String             '
End Type                        '
Private SeqTxt() As SeqTxt_Type ' Vettore delle corrispondenze Sequenza -> Testo.
Private NSeqTxt&                ' N di corrispondenze nel vettore SeqTxt().
Public FileSeqTxt$              ' File corrente delle corrispondenze Sequenze -> Testi.

Public Sub DTMF()
'
'   Imposta i parametri del codice DTMF:
'
    Dim I&, TolFreq#
'
    MaxTonesRX = 10
    MinToneWidth = 0.05 ' [s].
    MaxToneWidth = 3#   ' [s].
    MinInToneGap = 0.04 ' [s].
    MaxInToneGap = 2.4  ' [s].
    TolFreq = 3.5       ' Tolleranza sulla frequenza del tono [%].
'
    ToneWidth = DMIN1(DMAX1(ToneWidth, MinToneWidth), MaxToneWidth)
    InToneGap = DMIN1(DMAX1(InToneGap, MinInToneGap), MaxInToneGap)
'
    ' Vettore delle frequenze dei toni:
    NFreq = 8
    ReDim ToneFreq#(0 To NFreq - 1)
    ' Low-Group Frequencies:
    ToneFreq(0) = 697#
    ToneFreq(1) = 770#
    ToneFreq(2) = 852#
    ToneFreq(3) = 941#
    ' High-Group Frequencies:
    ToneFreq(4) = 1209#
    ToneFreq(5) = 1336#
    ToneFreq(6) = 1477#
    ToneFreq(7) = 1633#
'
    ' Vettori dei caratteri e dei loro indici di frequenza:
    NTones = 16     ' N totale di caratteri nella tabella.
    NTonesDec = 16  ' N di caratteri decodificabili.
    ReDim ToneChar$(0 To NTones - 1)
    ReDim IToneFreq1(0 To NTones - 1), IToneFreq2(0 To NTones - 1)
    ToneChar$(0) = "1":  IToneFreq1(0) = 0:  IToneFreq2(0) = 4
    ToneChar$(1) = "2":  IToneFreq1(1) = 0:  IToneFreq2(1) = 5
    ToneChar$(2) = "3":  IToneFreq1(2) = 0:  IToneFreq2(2) = 6
    ToneChar$(3) = "A":  IToneFreq1(3) = 0:  IToneFreq2(3) = 7
    ToneChar$(4) = "4":  IToneFreq1(4) = 1:  IToneFreq2(4) = 4
    ToneChar$(5) = "5":  IToneFreq1(5) = 1:  IToneFreq2(5) = 5
    ToneChar$(6) = "6":  IToneFreq1(6) = 1:  IToneFreq2(6) = 6
    ToneChar$(7) = "B":  IToneFreq1(7) = 1:  IToneFreq2(7) = 7
    ToneChar$(8) = "7":  IToneFreq1(8) = 2:  IToneFreq2(8) = 4
    ToneChar$(9) = "8":  IToneFreq1(9) = 2:  IToneFreq2(9) = 5
    ToneChar$(10) = "9": IToneFreq1(10) = 2: IToneFreq2(10) = 6
    ToneChar$(11) = "C": IToneFreq1(11) = 2: IToneFreq2(11) = 7
    ToneChar$(12) = "*": IToneFreq1(12) = 3: IToneFreq2(12) = 4
    ToneChar$(13) = "0": IToneFreq1(13) = 3: IToneFreq2(13) = 5
    ToneChar$(14) = "#": IToneFreq1(14) = 3: IToneFreq2(14) = 6
    ToneChar$(15) = "D": IToneFreq1(15) = 3: IToneFreq2(15) = 7
'
    ' Tabella delle corrispondenze indici di frequenza / carattere:
    ReDim TabDTMF$(0 To 3, 4 To 7)
    TabDTMF$(0, 4) = "1": TabDTMF$(0, 5) = "2": TabDTMF$(0, 6) = "3": TabDTMF$(0, 7) = "A"
    TabDTMF$(1, 4) = "4": TabDTMF$(1, 5) = "5": TabDTMF$(1, 6) = "6": TabDTMF$(1, 7) = "B"
    TabDTMF$(2, 4) = "7": TabDTMF$(2, 5) = "8": TabDTMF$(2, 6) = "9": TabDTMF$(2, 7) = "C"
    TabDTMF$(3, 4) = "*": TabDTMF$(3, 5) = "0": TabDTMF$(3, 6) = "#": TabDTMF$(3, 7) = "D"
'
    ' Calcolo i valori di tolleranza:
    ReDim DeltaFreq#(1 To 2, 0 To NFreq - 1)
    For I = 0 To NFreq - 1
        DeltaFreq(1, I) = ToneFreq(I) * (1# - TolFreq / 100#)
        DeltaFreq(2, I) = ToneFreq(I) * (1# + TolFreq / 100#)
    Next I
'
    TnFMin = DeltaFreq(1, 0)    ' 697  - %TolFreq [Hz].
    TnFMax = DeltaFreq(2, 7)    ' 1633 + %TolFreq [Hz].
'
'
'
End Sub
Public Sub CharToFreq_DTMF(ByVal Char$, ByRef Freq1 As Double, ByRef Freq2 As Double)
'
'   Ritorna le frequenze associate al carattere Char$:
'
    Dim I&
'
    For I = 0 To NTones - 1
        If (ToneChar$(I) = Char$) Then
            Freq1 = ToneFreq(IToneFreq1(I))
            Freq2 = ToneFreq(IToneFreq2(I))
            Exit Sub
        End If
    Next I
'
    ' Non ho trovato
    ' corrispondenze:
    Freq1 = -1#
    Freq2 = -1#
'
'
'
End Sub
Public Function LeggiFileSeqTxt(ByVal FileN$) As Boolean
'
'
    Dim FF%
'
    On Error GoTo LeggiFileSeqTxt_ERR
'
    NSeqTxt = 0
'
    FF = FreeFile
    Open FileN$ For Input As #FF
'
    Do While Not EOF(FF)
        NSeqTxt = NSeqTxt + 1
        ReDim Preserve SeqTxt(1 To NSeqTxt)
        Input #FF, SeqTxt(NSeqTxt).Sequenza, SeqTxt(NSeqTxt).Testo
    Loop
'
'
LeggiFileSeqTxt_ERR:
    Close #FF
    LeggiFileSeqTxt = (Err.Number = 0)
'
    If (Err.Number <> 0) Then
        Dim M$
        M$ = "Errore di lettura del file Sequenze -> Testi:" & vbNewLine
        M$ = M$ & "  " & FileN$ & vbNewLine & vbNewLine
        M$ = M$ & "Errore " & Str$(Err.Number) & vbNewLine
        M$ = M$ & Err.Description
        MsgBox M$, vbCritical, " modCodici: LeggiFileSeqTxt"
    End If
'
'
'
End Function
Public Function SeqToTxt(ByVal Sequenza$) As String
'
'   Ritorna il testo associato alla
'   sequenza Sequenza$:
'
    Dim I&
'
    For I = 1 To NSeqTxt
        If (Sequenza$ = SeqTxt(I).Sequenza) Then
            SeqToTxt = SeqTxt(I).Testo
            Exit Function
        End If
    Next I
'
    ' Non ho trovato
    ' corrispondenze:
    SeqToTxt = ""
'
'
'
End Function
Public Function CharToInd(ByVal Char$) As Long
'
'   Ritorna l' indice del carattere Char$:
'
    Dim I&
'
    For I = 0 To NTones - 1
        If (ToneChar$(I) = Char$) Then
            CharToInd = I
            Exit Function
        End If
    Next I
'
    ' Non ho trovato
    ' corrispondenze:
    CharToInd = -1
'
'
'
End Function
