Attribute VB_Name = "modDecoToni_DTMF"
'=======================================================================================
' Descrizione.....: Variabili, costanti e routines per l' invio,
'                   l' acquisizione e la decodifica di toni audio
'                   di tipo DTMF.
' Nome dei Files..: frmDecoToni_DTMF.frm, frmDecoToni_DTMF.frx,
'                   frmConsole.frm, frmConsole.frx,
'                   frmOpzioni.frm, frmOpzioni.frx,
'                   frmGrafici.frm, frmGrafici.frx,
'                   frmTastieraDTMF.frm, frmTastieraDTMF.frx,
'                   frmInfoCr.frm, frmInfoCr.frx,
'                   frmIstruzioni.frm, frmIstruzioni.frx,
'                   modDecoToni_DTMF_DTMF.bas, modDSP.bas, modComplex.bas,
'                   modCodici.bas, modUtilita.bas, modFlexPB.bas,
'                   modMixerControl.bas, modCommonDialog.
' Data............: 08/03/2004 (Ver. 1.0, Selettive).
' Aggiornamento...: 19/03/2004 (Ver. 2.1).
' Aggiornamento...: 11/01/2005 (Ver. 2.2, aggiunta la decodifica sequenze -> testi)
' Aggiornamento...: 05/07/2007 (Ver. 3.0 per DTMF).
' Aggiornamento...: 26/03/2010 (Ver. 4.0, nuova versione della gestione delle
'                               schede audio, etc...).
' Versione........: 4.0 a 32 bits.
' Sistema.........: VB6 (SP5) sotto Windows XP (SP2).
' Scritto da......: F. Languasco 
' E-Mail..........: MC7061@mclink.it
' DownLoads a.....: http://www.flanguasco.org
'=======================================================================================
'
'   Nota 1: questo progetto e' stato sviluppato usando il "." come
'           separatore decimale; nonostante abbia cercato di prevenire
'           possibili problemi dovuti all' uso della "," non posso
'           escludere che sia rimasta qualche incongruenza.
'           In caso di malfunzionamenti dovuti a questo problema,
'           provate a cambiare sul vostro PC le impostazioni interna-
'           zionali e datemi notizia dei "bugs" trovati.
'
'   Nota 2: ho introdotto l' unita' di misura [DigVal] per indicare valori
'           digitali a 16 Bits, i.e. quelli direttamente ritornati dal
'           convertitore A/D della scheda audio.
'           L' unita' [campioni] e' per le grandezze misurabili in [s * Fs].
'
Option Explicit
'
Public MixerSpI&        ' Indice, in MixerSp(), del mixer corrente di tipo SPEAKERS.
                        '  1 <= MixerSpI <= NMixSp.
Public MixerWiI&        ' Indice, in MixerWi(), del mixer corrente di tipo WAVEIN;
                        '  1 <= MixerWiI <= NMixWi.
'
Public FsRX#            ' Frequenza di campionamento in ricezione    [Hz].
Public FsTX#            '    "      "       "        "  trasmissione  "
'
Public NcRX&            ' N di campioni nei vettori dei dati per acquisizione [campioni].
Public NcToneRX&        ' N di campioni in un tono della sequenza ricevuta [campioni].
Private NcGapTX&        ' N di campioni nella pausa della sequenza da trasmettere [campioni].
Private VIn2!()         ' Vettore di accumulo per tutti i dati in ingresso [DigVal].
'
Public NcTX&            ' N di campioni nel vettore della sequenza da trasmettere [campioni].
Public TmsSeqTX&        ' Durata della sequenza da trasmettere [ms].
'
Private IcI&, IcIp&     ' Puntatore al campione corrente e per la (non) separazione delle sequenze [campioni].
'
Public TsSeqSep#        ' Intervallo per la separazione delle sequenze ricevute [s].
Public Const MinTsSeqSep# = 0.15 ' Minimo intervallo per la separazione delle sequenze ricevute [s].
Public Const MaxTsSeqSep# = 3#   ' Massimo intervallo per la separazione delle sequenze ricevute [s].
Private NcSeqSep&       ' N di campioni per la separazione delle sequenze ricevute [campioni].
Public MinCar&          ' N minimo di caratteri per una sequenza accettabile.
Private StringaRX$      ' Stringa di accumulo dei caratteri decodificati.
'
Public bSuonaOn As Boolean          ' Flag di SuonaSequenza in corso.
Public bAcqOn As Boolean            ' Flag di Acquisizione in corso.
'
Public bAutoScroll As Boolean       ' Flag di posizionamento automatico nella tabella delle strighe rivevute.
                                    ' (solo per il codice VVF, eliminato per riservatezza).
'
' Per decodifica con spettri mobili:
Private SpmMF#()            ' Vettore degli spettri mobili multifrequenza.
Private MMbSg#              ' Media (o valore efficace) mobile del segnale [DigVal].
Private Beta#               ' Rapporto minimo SPM/SMed.
Private NcSpmCont&()        ' Vettore dei numeri di campioni con spettro > Beta * valor medio [campioni].
Private NcSpmSuff&          ' SSC: N di soglia per il numero di campioni con spettro > Beta * valor medio [campioni].
Private NcToneRX_2&         ' Meta' del N di campioni in un tono [campioni].
'
' Per grafici:
Public ViMax!                       ' Scala verticale del grafico del segnale [DigVal].
Public IFreqSpettro&                ' Indice della frequenza per la quale e' richiesto
                                    ' il grafico dello spettro mobile; le frequenze sono
                                    ' quelle della tabella ToneFreq() con:
                                    '  0 <= IFreqSpettro <= 7.
'
Private Const MaxCar& = 200         ' Numero massimo di caratteri memorizzabili.
Private NcPosCharOffset&            ' Offset della posizione dei caratteri rispetto
                                    ' all' inizio del tono [campioni].
Private Char$(1 To MaxCar)          ' Vettore dei caratteri trovati
Private PosChar&(1 To MaxCar)       ' e loro relativa posizione.
Private SpmG#(), MMbG#()            ' Vettori di uno spettro mobile e della media mobile.
'
Public bDisegnaGrafici As Boolean   ' Flag di disegno dei grafici.
Public bSoloSequenze As Boolean     ' Flag di disegno delle sole porzioni di segnale
                                    ' contenenti caratteri validi.
'
Public bFiltroON As Boolean         ' Flag di filtro inserito.
Private FiltFMin#, FiltFMax#        ' Frequenze di taglio min. e Max del filtro
                                    ' passa-banda [f/fs].
'
                                    ' Filtro FIR:
Private Const NFilt& = 32           '  N di coefficienti del filtro.
'
                                    ' Filtro IIR:
Private NK&, NCel&                  '  Ordine e numero di sezioni,
Private w!()                        '  registri delle sezioni [DigVal],
Private Ac!(), Bc!()                '  e vettori dei coefficienti del filtro.
'
Public Const NCanali% = 1           ' Deve essere Mono.
Public Const BitsPerSample% = 16    ' Risoluzione del campionamento.  In questa
                                    ' versione e' sempre di 16 bits.
'
Public Const Amp16Max# = 32767#     ' Massima ampiezza del suono a 16 bits.
Public AmpOut#                      ' Ampiezza del suono emesso.
'
' Per Acquisizione:
Private phwi&           ' Handle del "waveform-audio input device".
Private NBuff&          ' N di buffers per l' acquisizione.
Private InData%()       ' Matrice dei dati acquisiti (Integer, per acquisizione a 16 bits) [DigVal].
Private InDataC%()      ' Vettore copia dei buffers di acquisizione [DigVal].
Private WaveInHdr() As WAVEHDR
Private LenInHeaders&   ' = Len(WaveInHdr(1))
'
' Per SuonaSequenza:
Private phwo&           ' Handle del "waveform-audio output device".
Private OutData%()      ' Vettore dei dati da emettere (Integer, per suono a 16 bits) [DigVal].
Private WaveOutHdr As WAVEHDR
Private LenOutHeader&   ' = Len(WaveOutHdr)
'
Public FileINI$         ' File dei parametri dello strumento.
'
'--  Costanti, tipi e dichiarazioni per API: -------------------------------------------
'
Private Declare Function GetTickCount Lib "kernel32" () As Long
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
'
Public Const WHDR_DONE& = &H1&      ' /* done bit */
Private Const WAVE_FORMAT_PCM& = 1
'
Private Const MMSYSERR_NOERROR& = 0 ' no error
'
Private Type WAVEHDR
    lpData As Long
    dwBufferLength As Long
    dwBytesRecorded As Long
    dwUser As Long
    dwFlags As Long
    dwLoops As Long
    lpNext As Long  ' Reserved.
    Reserved As Long
End Type
'
Private Type WAVEFORMATEX
    wFormatTag As Integer
    nChannels As Integer
    nSamplesPerSec As Long
    nAvgBytesPerSec As Long
    nBlockAlign As Integer
    wBitsPerSample As Integer
    cbSize As Integer
End Type
'
'-- WaveOut: ---------------------------------------------------------------------------
'
Private Declare Function waveOutOpen Lib "winmm.dll" _
    (lphWaveOut As Long, ByVal uDeviceID As Long, _
    ByVal lpFormat As Long, ByVal dwCallback As Long, _
    ByVal dwInstance As Long, ByVal dwFlags As Long) As Long
Public Declare Function waveOutClose Lib "winmm.dll" (ByVal hWaveOut As Long) As Long
'
Private Declare Function waveOutPrepareHeader Lib "winmm.dll" _
    (ByVal hWaveOut As Long, lpWaveOutHdr As WAVEHDR, ByVal uSize As Long) As Long
Public Declare Function waveOutUnprepareHeader Lib "winmm.dll" _
    (ByVal hWaveOut As Long, lpWaveOutHdr As WAVEHDR, ByVal uSize As Long) As Long
'
Private Declare Function waveOutWrite Lib "winmm.dll" _
    (ByVal hWaveOut As Long, lpWaveOutHdr As WAVEHDR, ByVal uSize As Long) As Long
Public Declare Function waveOutReset Lib "winmm.dll" (ByVal hWaveOut As Long) As Long
'
'-- WaveIn: ----------------------------------------------------------------------------
'
Private Declare Function waveInOpen Lib "winmm.dll" _
    (WaveDeviceInputHandle As Long, ByVal WhichDevice As Long, _
    ByVal WaveFormatExPointer As Long, ByVal CallBack As Long, _
    ByVal CallBackInstance As Long, ByVal Flags As Long) As Long
Public Declare Function waveInClose Lib "winmm.dll" _
    (ByVal WaveDeviceInputHandle As Long) As Long
'
Private Declare Function waveInPrepareHeader Lib "winmm.dll" _
    (ByVal InputDeviceHandle As Long, ByVal WaveHdrPointer As Long, _
    ByVal WaveHdrStructSize As Long) As Long
Public Declare Function waveInUnprepareHeader Lib "winmm.dll" _
    (ByVal InputDeviceHandle As Long, ByVal WaveHdrPointer As Long, _
    ByVal WaveHdrStructSize As Long) As Long
Private Declare Function waveInAddBuffer Lib "winmm.dll" _
    (ByVal InputDeviceHandle As Long, ByVal WaveHdrPointer As Long, _
    ByVal WaveHdrStructSize As Long) As Long
'
Private Declare Function waveInStart Lib "winmm.dll" _
    (ByVal WaveDeviceInputHandle As Long) As Long
Public Declare Function waveInReset Lib "winmm.dll" _
    (ByVal WaveDeviceInputHandle As Long) As Long
'
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" _
    (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)

Private Sub Decodifica_DTMF(InData() As Integer)
'
'   Routine per la decodifica del segnale in ingresso.
'   Questa routine e' chiamata da Acquisisizione ogni
'   volta che e' pronto un nuovo vettore InData().
'   Routine con decodifica di tutti i dati in ingresso,
'   i.e. senza attesa della pausa e con spettro mobile.
'   Ver: 11/07/05 (per DTMF).
'
    Dim I&, J&, L&, IcF1&, IcF2&, IF1&, IF2&, K&, NChar&, Y!
    Static bPausa As Boolean
'
    On Error Resume Next    ' Gestisce l' overflow occasionale di Char$() e PosChar&().
'
    NChar = 0
    For I = 1 To NcRX   ' I e' la coord. temporale (N di campione) all' interno
                        ' del blocco InData() di dati acquisiti.
        IcI = IcI + 1   ' IcI e' la coord. temporale (N di campione) dalla
                        ' fine dell' ultimo tono decodificato.
'
        If bFiltroON Then
            ' Filtro FIR i dati in ingresso:
            'VIn2(I) = FIR(CSng(InData(I)))
'
            ' Filtro IIR i dati in ingresso.
            ' VIn2(I) = IIR(CSng(InData(I))) sviluppato
            ' in linea per velocizzare il calcolo:
            Y = InData(I)
            For J = 1 To NCel
                w(0, J) = Y
                Y = 0!
                For L = NK To 1 Step -1
                    w(0, J) = w(0, J) - Bc(L, J) * w(L, J)
                    Y = Y + Ac(L, J) * w(L, J)
                    w(L, J) = w(L - 1, J)
                Next L
                Y = Y + Ac(0, J) * w(0, J)
            Next J
'
            VIn2(I) = Y
'
        Else
            ' Non filtro i dati in ingresso:
            VIn2(I) = CSng(InData(I))
        End If
'
        ' Calcolo gli spettri mobili alle
        ' frequenze della tabella dei toni:
        SPM_MF_R IcI, VIn2(I), SpmMF(), MMbSg
'
        For K = 0 To NFreq - 1
            ' Il valore dello spettro alla
            ' frequenza ToneFreq(K) e' mag-
            ' giore del valor medio corrente?
            If (Beta * MMbSg < SpmMF(K)) And (1 < MMbSg) Then
                ' Si, incremento il numero di
                ' campioni sopra la media:
                NcSpmCont(K) = NcSpmCont(K) + 1
            Else
                ' No, il valore dello spettro
                ' e' sceso sotto il valor medio
                ' e quindi azzero la somma:
                NcSpmCont(K) = 0
            End If
        Next K
'
        ' Esploro le "Low-Group Frequencies":
        IcF1 = 0
        For K = 0 To 3
            If (NcSpmSuff < NcSpmCont(K)) Then
                ' Il numero di campioni con spettro
                ' superiore alla media, per la frequenza
                ' K, ha superato il valore stabilito:
                IcF1 = IcF1 + 1
                IF1 = K
            End If
        Next K
'
        ' Esploro le "High-Group Frequencies":
        IcF2 = 0
        For K = 4 To 7
            If (NcSpmSuff < NcSpmCont(K)) Then
                ' Il numero di campioni con spettro
                ' superiore alla media, per la frequenza
                ' K, ha superato il valore stabilito:
                IcF2 = IcF2 + 1
                IF2 = K
            End If
        Next K
'
        If (IcF1 = 1) And (IcF2 = 1) And bPausa Then
            ' E' stato riconosciuto un tono valido:
            bPausa = False
'
            ' Aggiungo alla stringa ricevuta
            ' il codice del tono trovato:
            StringaRX$ = StringaRX$ & TabDTMF$(IF1, IF2)
'
            ' Memorizzo, per il grafico, il carattere trovato:
            NChar = NChar + 1
            PosChar(NChar) = I + NcPosCharOffset
            Char$(NChar) = TabDTMF$(IF1, IF2)
'
        ElseIf ((IcF1 <> 1) Or (IcF2 <> 1)) And (Not bPausa) Then
            ' Il tono valido riconosciuto e' finito:
            bPausa = True
            IcIp = 0
'
            ' Riazzero il contatore dei campioni IcI (questo
            ' fa' anche ripartire il calcolo del valor medio
            ' in SPM_MF_R):
            IcI = 0
        End If
'
        If (IcF1 = 0) And (IcF2 = 0) And (0 < Len(StringaRX$)) Then
            ' Misuro la durata della pausa con
            ' il contatore IcIp:
            IcIp = IcIp + 1
        End If
'
        ' Se sono trascorsi piu' di NcSeqSep campioni
        ' dalla fine dell' ultimo tono decodificato,
        ' allora elaboro la stringa finora formata:
        If (NcSeqSep < IcIp) Then
            ' Ignoro le sequenze con un numero di caratteri inferiore
            ' a MinCar e tratto, invece, quelle piu' lunghe:
            If (MinCar <= Len(StringaRX$)) Then frmConsole.ScriviStringaRX_SSC StringaRX$
            StringaRX$ = ""
            IcIp = 0
        End If
'
        ' Preparo i vettori per il grafico:
        SpmG(I) = SpmMF(IFreqSpettro)
        MMbG(I) = MMbSg
    Next I
'
    If bDisegnaGrafici And ((Not bSoloSequenze) Or (0 < NChar)) Then
        ' Disegno il grafico di segnale,
        ' spettro mobile e valor medio:
        frmGrafici.DisegnaGrafici_DTMF VIn2(), SpmG(), MMbG(), _
                                       NChar, PosChar(), Char$()
    End If
'
'
    If (Err.Number <> 0) Then Err.Clear
'
'
'
End Sub
Public Sub ImpostaParametri()
'
'
    On Error GoTo ImpostaParametri_ERR
'
    ' Leggo le corrispondenze Sequenza -> Testo:
    If FileExists(FileSeqTxt$) Then
        LeggiFileSeqTxt FileSeqTxt$
    Else
        FileSeqTxt$ = ""
    End If
'
'---------------------------------------------------------------------------------------
    ' Parametri della ricezione/decodifica:
'
    ' N minimo di campioni in un tono:
    NcToneRX = CLng(MinToneWidth * FsRX)
'
    ' N di campioni per la separazione
    ' delle sequenze ricevute:
    NcSeqSep = TsSeqSep * FsRX
'
    ' N di campioni nella matrice InData()
    ' e nel vettore InDataC() di acquisizione:
    NcRX = CLng((CDbl(MaxTonesRX) * (MinToneWidth + MinInToneGap)) * FsRX)
'
    ' Per decodifica del segnale completo:
    ReDim VIn2(1 To NcRX)
'
    ' Inizializzo lo spettro mobile:
    SPM_MF_Init NcToneRX / 4, NFreq, ToneFreq(), FsRX   ' Multi frequenza.
    ReDim SpmMF(0 To NFreq - 1)                         '   "      "
    ReDim NcSpmCont(0 To NFreq - 1)                     '   "      "
'
    ' Parametri per spettro mobile:
    NcToneRX_2 = NcToneRX / 2
    NcSpmSuff = CLng(0.75 * NcToneRX)
    NcPosCharOffset = NcToneRX_2 - NcSpmSuff
    Beta = 0.65 ' Diminuendo questo valore aumenta la sensibilita' della
                ' decodifica ma aumenta la probabilita' di errore, cioe'
                ' di trovare toni DTMF in segnali che non li contengono...
'
'---------------------------------------------------------------------------------------
    ' Filtri (solo in ricezione):
'
    FiltFMin = TnFMin / FsRX  ' Frequenze di taglio min.
    FiltFMax = TnFMax / FsRX  ' e Max. del filtro passa banda [f/fs].
'
    ' Calcolo il filtro FIR:
    SintesiFIR_WM "Band Pass", NFilt, FiltFMin, FiltFMax, "Lanczos", 0.6
'
    ' Calcolo il filtro IIR:
    SintesiIIR_BT "Low Pass -> Band Pass", "Chebyshev", 0.2, 0.25, -20#, 1#, _
                  FiltFMin, FiltFMax
'
    ' Copia locale dei parametri del filtro IIR:
    LeggiCoefficienti_IIR NK, NCel, w(), Ac(), Bc()
'
'---------------------------------------------------------------------------------------
    ' Inizializzazione dei grafici:
'
    ReDim SpmG(1 To NcRX)
    ReDim MMbG(1 To NcRX)
'
    frmGrafici.Apri NcRX
'
'
ImpostaParametri_ERR:
    If (Err <> 0) Then
        Dim a$
        a$ = Err.Description & vbNewLine & vbNewLine
        a$ = a$ & "Valori dei parametri:" & vbNewLine & vbNewLine
        a$ = a$ & "Codice = " & Codice$ & vbNewLine
        a$ = a$ & "FsRX = " & FsRX & vbNewLine
        a$ = a$ & "FsTX = " & FsTX & vbNewLine
        a$ = a$ & "AmpOut = " & AmpOut & vbNewLine
        a$ = a$ & "bAutoScroll = " & bAutoScroll & vbNewLine
        a$ = a$ & "MinCar = " & MinCar & vbNewLine
        a$ = a$ & "NcSeqSep = " & NcSeqSep & vbNewLine
        a$ = a$ & "bFiltroON = " & bFiltroON & vbNewLine
'
        a$ = a$ & vbNewLine
        a$ = a$ & "MaxTonesRX = " & MaxTonesRX & vbNewLine
        a$ = a$ & "MinToneWidth = " & MinToneWidth & vbNewLine
        a$ = a$ & "ToneWidth = " & ToneWidth & vbNewLine
        a$ = a$ & "MinInToneGap = " & MinInToneGap & vbNewLine
        a$ = a$ & "InToneGap = " & InToneGap & vbNewLine
        a$ = a$ & "NcRX = " & NcRX & vbNewLine
        MsgBox a$, vbCritical, " ImpostaParametri"
    End If
'
'
'
End Sub
Private Sub Main()
'
'   Routine di ingresso del programma decodifica toni.
'
    ' Verifico la disponibilita' di almeno una scheda audio:
    If (Not CercaSchedeAudio) Then
        MsgBox "Questo PC non ha schede audio.", _
               vbCritical, " modDecoToni_DTMF: Main"
        Exit Sub
    End If
'
    ' Trovo i mixers audio disponibili nel sistema:
    If (Not CercaMixersSp) Or (Not CercaMixersWi) Then
        MsgBox "La ricerca dei mixers audio ha" & vbNewLine & _
               "trovato una condizione imprevista." & vbNewLine & vbNewLine & _
               "Per la selezione dei canali di ingresso" & vbNewLine & _
               "provare ad usare il ""Volume Control""" & vbNewLine & _
               "di Windows." & vbNewLine, _
               vbCritical, " modDecoToni_DTMF: Main"
    End If
'
    FileINI$ = App.Path & "\DecoToni_DTMF.ini"
    LeggiParametri
    Call DTMF
'
    ImpostaParametri
'
    frmDecoToni_DTMF.Show
    frmConsole.Show
    frmTastiera_DTMF.Show
'
    If IsLoaded(frmOpzioni) Then Unload frmOpzioni
'
    ' "Splash Form" iniziale:
    frmCopyright.Apri frmDecoToni_DTMF, vbModeless, 4
'
'
'
End Sub
Public Sub Acquisizione(ByVal uDeviceWiID As Long)
'
'   Routine per l' acquisizione e la visualizzazione/analisi
'   dei dati.
'   Lavora con NBuff buffers alternati i.e., quando un buffer e'
'   completo viene inviato alle routines di analisi/visualizzazione
'   e subito dopo rimesso in coda, mentre il successivo e' gia' in
'   fase di di acquisizione.
'   Ver: 10/04/09.
'
    Dim Ib&, NBytes&, t0&, TmsBuffErr&, TmsAcq&, TmsProc&, lRet&, M$
    Dim FormatWaveIn As WAVEFORMATEX
'
    On Error GoTo Acquisizione_ERR
'
    NBuff = 4
    NBytes = 2 * NcRX * NCanali
    TmsAcq = 1000 * NcRX / FsRX   ' [ms].
    frmConsole.lblTempoAcq = Format$(TmsAcq, "#0.0")
'
    ' Preparo/ripulisco i registri
    ' delle sezioni del filtro IIR:
    ReDim w(0 To NK, 1 To NCel)
'
    frmConsole.cmdCancellaSeq_Click
    DoEvents
'
    TmsBuffErr = MAX0(10 * NBuff * TmsAcq, 500) ' massimo tempo di attesa per
                                                ' il riempimento dei buffers [ms].
'
'-- Preparazione al waveInStart: -------------------------------------------------------
'
    ' Operazione di sicurezza, nel caso il programma sia
    ' stato precedentemente terminato in modo non corretto:
    phwi = CLng(GetIniString(FileINI$, "Parametri:", "phwi", "0"))
    lRet = waveInClose(phwi)
'
    ' Imposto, inizialmente, lo stato
    ' della scheda audio:
    With FormatWaveIn
        .wFormatTag = WAVE_FORMAT_PCM
        .nChannels = NCanali
        .nSamplesPerSec = CLng(FsRX) ' [Hz]
        .wBitsPerSample = BitsPerSample
        .nBlockAlign = (.nChannels * .wBitsPerSample) \ 8
        .nAvgBytesPerSec = .nBlockAlign * .nSamplesPerSec
        .cbSize = 0
    End With
'
    ' Apro il collegamento con la scheda audio ...:
    lRet = waveInOpen(phwi, uDeviceWiID, VarPtr(FormatWaveIn), 0, 0, 0)
    ' ... e ne salvo l' handler per un eventuale tentativo
    ' di recupero in caso di forzata chiusura senza [Stop]:
    SaveIniString FileINI$, "Parametri:", "phwi", phwi
'
    If (lRet <> MMSYSERR_NOERROR) Or (phwi = 0) Then
        M$ = "Il collegamento con la scheda audio non e' disponibile." & vbNewLine & vbNewLine
        M$ = M$ & "Si consiglia di chiudere tutti i programmi che potrebbero" & vbNewLine
        M$ = M$ & "usare la scheda audio o di riavviare il PC." & vbNewLine & vbNewLine
        M$ = M$ & "waveInOpen - Err: " & WaveERR(lRet)
        MsgBox M$, vbCritical, " modDecoToni_DTMF: Acquisizione"
        lRet = waveInClose(phwi)
        Exit Sub
    End If
'
    ReDim WaveInHdr(1 To NBuff) As WAVEHDR
    ReDim InData(1 To NcRX, 1 To NBuff) As Integer
    ReDim InDataC(1 To NcRX) As Integer
'
    ' Preparo i buffers per l' acquisizione dei dati:
    For Ib = 1 To NBuff
        WaveInHdr(Ib).lpData = VarPtr(InData(1, Ib))
        WaveInHdr(Ib).dwBufferLength = NBytes ' [Bytes].
        WaveInHdr(Ib).dwUser = Ib
        WaveInHdr(Ib).dwFlags = 0
        WaveInHdr(Ib).dwLoops = 0
'
        lRet = waveInPrepareHeader(phwi, VarPtr(WaveInHdr(Ib)), Len(WaveInHdr(Ib)))
        If (lRet <> MMSYSERR_NOERROR) Then _
            Err.Raise 1001, , "waveInPrepareHeader #" & Ib & " - Err: " & WaveERR(lRet)
    Next Ib
    LenInHeaders = Len(WaveInHdr(1))
'
    ' Inizio l' acquisizione con il buffer #1 e metto
    ' in coda l' acquisizione con gli altri buffers:
    For Ib = 1 To NBuff
        lRet = waveInAddBuffer(phwi, VarPtr(WaveInHdr(Ib)), LenInHeaders)
        If (lRet <> MMSYSERR_NOERROR) Then
            Err.Raise 1001, , "waveInAddBuffer #" & Ib & " - Err: " & WaveERR(lRet)
        End If
    Next Ib
    Ib = 1
'
'-- Acquisizione: ----------------------------------------------------------------------
'
    lRet = waveInStart(phwi)    ' Inizio il collegamento con la scheda audio.
    If (lRet <> MMSYSERR_NOERROR) Then
        Err.Raise 1001, , "waveInStart - Err: " & WaveERR(lRet)
    End If
    bAcqOn = True               ' L' acquisizione e' in corso.
'
    Do
        frmConsole.lblIb.Caption = Ib
'
        t0 = GetTickCount   ' [ms].
        Do  ' Attendo il riempimento del buffer Ib.
            Sleep 0    ' Serve per il .exe; non necessario in IDE.
            DoEvents
'
            If (TmsBuffErr < (GetTickCount - t0)) Then
                Err.Raise 1001, , "Il sistema non risponde."
            End If
        Loop Until ((WaveInHdr(Ib).dwFlags And WHDR_DONE) = WHDR_DONE)
'
        ' Solo per informazione/Debug:
        t0 = GetTickCount
'
        ' Copio il buffer Ib nel vettore InDataC() da passare all' analisi:
        CopyMemory InDataC(1), InData(1, Ib), NBytes
'
        ' Rimetto in coda per l' acquisizione il buffer Ib:
        lRet = waveInAddBuffer(phwi, VarPtr(WaveInHdr(Ib)), LenInHeaders)
'
        ' Mando alla decodifica i dati copia del buffer Ib:
        Decodifica_DTMF InDataC()
'
        ' Solo per informazione/Debug:
        If bAcqOn Then
            TmsProc = GetTickCount - t0   ' [ms].
            frmConsole.lblTempoProc = Format$(TmsProc, "#0.0")
            If (TmsAcq < TmsProc) Then
                frmConsole.lblTempoProc.BackColor = vbRed
            Else
                frmConsole.lblTempoProc.BackColor = vbButtonFace
            End If
        End If
'
        ' Calcolo l' indice del buffer successivo:
        Ib = Ib + 1
        If (NBuff < Ib) Then Ib = 1
'
        DoEvents
    Loop While bAcqOn
'
'
Acquisizione_ERR:
    If (Err.Number <> 0) Then
        M$ = "Errore " & Str$(Err.Number) & vbNewLine
        M$ = M$ & Err.Description
        MsgBox M$, vbCritical, " modDecoToni_DTMF: Acquisizione"
    End If
'
    lRet = waveInReset(phwi)
'
    ' Libero i buffers di acquisizione dei dati ...:
    For Ib = 1 To NBuff
        lRet = waveInUnprepareHeader(phwi, VarPtr(WaveInHdr(Ib)), LenInHeaders)
    Next Ib
'
    ' ... e chiudo il collegamento con la scheda audio:
    lRet = waveInClose(phwi)
'
'
'
End Sub
Public Sub SuonaSequenza(ByVal uDeviceSpID As Long, _
    ByVal StringaTX$, ByVal DurataTono As Double)
'
'   Rev. 28/03/2005 (3 versione)
'   Rev. 07/07/2005 (4 versione, per DTMF)
'   Rev. 29/03/2010 (5 versione,  "   "  )
'
    Dim I&, Ci&, K&, lRet&, AmpOut_2#, Freq1#, Freq2#, Omega1#, Omega2#, ox#, M$
    Dim NcToneTX&           ' N di campioni in un tono.
    Dim bTono As Boolean    ' Flag di generazione di un tono.
    Dim FormatWaveOut As WAVEFORMATEX
'
    If (Len(StringaTX$) = 0) Then Exit Sub
'
    ' Calcolo il numero di campioni da emettere ...:
    NcToneTX = CLng(DurataTono * FsTX)  ' N di campioni nel tono.
    NcGapTX = CLng(InToneGap * FsTX)    ' N di campioni nella pausa.
    NcTX = Len(StringaTX$) * (NcGapTX + NcToneTX) - NcGapTX
'
    ' ... e dimensiono di conseguenza il vettore da "suonare":
    ReDim OutData(1 To NcTX * NCanali)
'
    TmsSeqTX = 1000 * NcTX / FsTX   ' Durata della sequenza da trasmettere [ms].
'
    ' Preparo il vettore OutData()
    ' con i toni da "suonare":
    K = 0
    Ci = 0
    bTono = True
    AmpOut_2 = AmpOut / 2#
'
    For I = 1 To NcTX
        If (K < I) And bTono Then
            ' Trovo il carattere da emettere e ne
            ' imposto la frequenza corrispondente:
            Ci = Ci + 1
            CharToFreq_DTMF Mid$(StringaTX$, Ci, 1), Freq1, Freq2
            Omega1 = PI2 * Freq1 / FsTX
            Omega2 = PI2 * Freq2 / FsTX
'
            ' Queste frequenze verranno mantenute
            ' per i successivi NcToneTX campioni:
            K = I + NcToneTX
            bTono = False
        End If
'
        If (K < I) And (Not bTono) Then
            ' Imposto la frequenza di pausa:
            Omega1 = 0#
            Omega2 = 0#
'
            ' Queste frequenze, che risultano in
            ' ox = 0 i.e. in una pausa, verranno
            ' mantenute per i successivi NcGapTX
            ' campioni:
            K = I + NcGapTX
            bTono = True
        End If
'
        ox = AmpOut_2 * (Sin(Omega1 * CDbl(I)) + Sin(Omega2 * CDbl(I)))
        If (Amp16Max < ox) Then ox = Amp16Max
        OutData(I) = CInt(ox)
    Next I
'
'---------------------------------------------------------------------------------------
'
    ' Chiudo, eventualmente, il collegamento con la scheda audio:
    TerminaSuonoSequenza True
'
    ' Imposto lo stato della scheda audio:
    With FormatWaveOut
        .wFormatTag = WAVE_FORMAT_PCM           ' uncompressed sound format.
        .nChannels = NCanali                    ' 1 = mono; 2 = stereo.
        .wBitsPerSample = BitsPerSample         ' bits per sample per channel.
        .nSamplesPerSec = CLng(FsTX)            ' samples per second.
        .nBlockAlign = .nChannels * .wBitsPerSample / 8
        .nAvgBytesPerSec = .nSamplesPerSec * .nBlockAlign
        .cbSize = 0
    End With
'
    ' Apro il collegamento con la scheda audio:
    lRet = waveOutOpen(phwo, uDeviceSpID, VarPtr(FormatWaveOut), 0, 0, 0)
    If (lRet <> MMSYSERR_NOERROR) Then
        MsgBox "waveOutOpen - Err: " & WaveERR(lRet), vbCritical, _
               " modDecoToni_DTMF: SuonaSequenza"
        Call phwoCleanUp
        Exit Sub
    End If
'
    If (phwo = 0) Then
        M$ = "Il collegamento con la scheda audio non e' disponibile." & vbNewLine & vbNewLine
        M$ = M$ & "Si consiglia di chiudere tutti i programmi che potrebbero" & vbNewLine
        M$ = M$ & "usare la scheda audio o di riavviare il PC." & vbNewLine
        MsgBox M$, vbExclamation, " modDecoToni_DTMF: SuonaSequenza"
        Exit Sub
    End If
'
    ' Preparo il buffer per l' emissione dei dati:
    WaveOutHdr.lpData = VarPtr(OutData(1))
    WaveOutHdr.dwBufferLength = Len(OutData(1)) * NcTX
    WaveOutHdr.dwFlags = 0&
    WaveOutHdr.dwLoops = 0&
    WaveOutHdr.dwBytesRecorded = 0&
    WaveOutHdr.dwUser = 1&
    WaveOutHdr.lpNext = 0&
    LenOutHeader = Len(WaveOutHdr)
    lRet = waveOutPrepareHeader(phwo, WaveOutHdr, LenOutHeader)
    If (lRet <> MMSYSERR_NOERROR) Then
        MsgBox "waveOutPrepareHeader - Err: " & WaveERR(lRet), vbCritical, _
               " modDecoToni_DTMF: SuonaSequenza"
        Call phwoCleanUp
        Exit Sub
    End If
'
'---------------------------------------------------------------------------------------
'
    ' Suono il buffer dei toni:
    lRet = waveOutWrite(phwo, WaveOutHdr, LenOutHeader)
'
'
'
End Sub
Private Sub phwoCleanUp()
'
'
    Dim lRet&
'
    On Local Error Resume Next
'
    If (phwo <> 0) Then
        lRet = waveOutReset(phwo)
        lRet = waveOutClose(phwo)
        phwo = 0
    End If
'
'
'
End Sub
Public Sub SalvaParametri()
'
'   Salva, su file .INI, i parametri correntemente usati:
'
    ' Form frmOpzioni:
    SaveIniString FileINI$, "Parametri:", "MixerSpI", MixerSpI
    SaveIniString FileINI$, "Parametri:", "MixerWiI", MixerWiI
'
    ' Questa versione e' solo per DTMF:
    'SaveIniString FileINI$, "Parametri:", "Codice", Codice$
'
    SaveIniString FileINI$, "Parametri:", "FileSeqTxt", FileSeqTxt$
    SaveIniString FileINI$, "Parametri:", "FsRX", FsRX
    SaveIniString FileINI$, "Parametri:", "FsTX", FsTX
    SaveIniString FileINI$, "Parametri:", "AmpOut", AmpOut
'
    ' Form frmConsole:
    SaveIniString FileINI$, "Parametri:", "bAutoScroll", bAutoScroll
    SaveIniString FileINI$, "Parametri:", "Filtro ON", bFiltroON
'
    SaveIniString FileINI$, "Parametri:", "ToneWidth", ToneWidth
    SaveIniString FileINI$, "Parametri:", "InToneGap", InToneGap
'
    SaveIniString FileINI$, "Parametri:", "MinCar", MinCar
    SaveIniString FileINI$, "Parametri:", "TsSeqSep", TsSeqSep
'
    ' Form frmGrafici:
    SaveIniString FileINI$, "Parametri:", "Grafico ViMax", ViMax
'
'
'
End Sub
Private Sub LeggiParametri()
'
'   Legge (ed eventualmente corregge), dal file .INI, i parametri preferenziali:
'
    On Error Resume Next
'
    ' Form frmOpzioni:
    MixerSpI = CLng(GetIniString(FileINI$, "Parametri:", "MixerSpI", "1"))
    MixerSpI = MAX0(MIN0(MixerSpI, NMixSp), 1)
    MixerWiI = CLng(GetIniString(FileINI$, "Parametri:", "MixerWiI", "1"))
    MixerWiI = MAX0(MIN0(MixerWiI, NMixWi), 1)
'
    ' Questa versione e' solo per DTMF:
    Codice$ = "DTMF"
'
    FileSeqTxt$ = GetIniString(FileINI$, "Parametri:", "FileSeqTxt", "Sequenze_Testi.txt")
    FsRX = Val(ValC2D(GetIniString(FileINI$, "Parametri:", "FsRX", 11025#)))
    FsRX = DMAX1(FsRX, 8000)
    FsTX = Val(ValC2D(GetIniString(FileINI$, "Parametri:", "FsTX", 11025#)))
    FsTX = DMAX1(FsTX, 8000)
    AmpOut = Val(ValC2D(GetIniString(FileINI$, "Parametri:", "AmpOut", Amp16Max / 10#)))
    AmpOut = DMAX1(AmpOut, 1000)
'
    ' Form frmConsole:
    bAutoScroll = CBool(GetIniString(FileINI$, "Parametri:", "bAutoScroll", True))
    bFiltroON = CBool(GetIniString(FileINI$, "Parametri:", "Filtro ON", True))
'
    ToneWidth = Val(ValC2D(GetIniString(FileINI$, "Parametri:", "ToneWidth", 0.2)))
    InToneGap = Val(ValC2D(GetIniString(FileINI$, "Parametri:", "InToneGap", 0.05)))
'
    MinCar = CLng(GetIniString(FileINI$, "Parametri:", "MinCar", 1&))
    MinCar = MAX0(MIN0(MinCar, 16), 1)
    TsSeqSep = Val(ValC2D(GetIniString(FileINI$, "Parametri:", "TsSeqSep", 0.15)))
    TsSeqSep = DMAX1(TsSeqSep, 0.15)
'
    ' Form frmGrafici:
    ViMax = Val(ValC2D(GetIniString(FileINI$, "Parametri:", "Grafico ViMax", 10000!)))
'
'
    If (Err.Number <> 0) Then Err.Clear
'
'
'
End Sub
Public Sub TerminaSuonoSequenza(Optional ByVal bAttesaFineSuono As Boolean = False)
'
'
    Dim t0&, lRet&
'
    If (phwo <> 0) Then
        If (Not bAttesaFineSuono) Then lRet = waveOutReset(phwo)
'
        ' Attendo la fine della "suonata" in corso:
        t0 = GetTickCount   ' [ms].
        Do
        Loop Until ((WaveOutHdr.dwFlags And WHDR_DONE) = WHDR_DONE) _
                Or (2 * TmsSeqTX < (GetTickCount - t0))
'
        ' Libero il buffer di emissione dei dati ...:
        lRet = waveOutUnprepareHeader(phwo, WaveOutHdr, LenOutHeader)
        If (lRet <> MMSYSERR_NOERROR) Then
            MsgBox "waveOutUnPrepareHeader - Err: " & WaveERR(lRet), vbCritical, _
                   " modDecoToni_DTMF: TerminaSuonoSequenza"
        End If
'
        ' ... e chiudo il collegamento con la scheda audio:
        lRet = waveOutClose(phwo)
        If (lRet <> MMSYSERR_NOERROR) Then
          MsgBox "waveOutClose - Err: " & WaveERR(lRet), vbCritical, _
                 " modDecoToni_DTMF: TerminaSuonoSequenza"
        End If
        phwo = 0
    End If
'
'
'
End Sub
