Attribute VB_Name = "modUtilita"
'=======================================================================================
' Descrizione.....: Routines di utilita' per decodifica toni; non tutte le routines
'                   e costanti di questo modulo vengono, necessariamente, usate.
' Nome dei Files..: modUtilita.bas
' Data............: 13/06/1999
' Aggiornamento...: 31/03/2001
' Versione........: 1.1 a 32 bits.
' Sistema.........: VB6 (SP5) sotto Windows XP (SP2).
' Scritto da......: F. Languasco 
' E-Mail..........: MC7061@mclink.it
' DownLoads a.....: http://www.flanguasco.org
'=======================================================================================
'
Option Explicit
'
Public Const PI# = 3.14159265358979     ' 4# * Atn(1#)
Public Const PI_2# = PI / 2#
Public Const PI2# = 2# * PI
Public Const Log2# = 0.693147180559945  ' Log(2#)
Public Const Log10# = 2.30258509299405  ' Log(10#)
Public Const Sqr2# = 1.4142135623731    ' Sqr(2#)
Public Const KNote# = 1.0594630943593   ' 2 ^ (1/12)
'
Public Const ColEvi& = vbInfoBackground ' Colore degli evidenziatori.
'
'--- SysSep: ---------------------------------------------------------
Private Declare Function GetLocaleInfo Lib "kernel32" Alias "GetLocaleInfoA" _
(ByVal Locale As Long, ByVal LCType As Long, ByVal lpLCData As String _
, ByVal cchData As Long) As Long
Private Declare Function GetThreadLocale Lib "kernel32" () As Long
'
Private Const LOCALE_STHOUSAND& = &HF
Private Const LOCALE_SDECIMAL& = &HE
'
'--- GetIniString, SaveIniString: ------------------------------------------------------
Private Declare Function GetPrivateProfileString Lib "kernel32" _
    Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, _
    ByVal lpKeyName As Any, ByVal lpDefault As String, _
    ByVal lpReturnedString As String, ByVal nSize As Long, _
    ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileString Lib "kernel32" _
    Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, _
    ByVal lpKeyName As Any, ByVal lpString As Any, _
    ByVal lpFileName As String) As Long
'
'--- Remove Menu: ---------------------------------------------------------
Private Declare Function RemoveMenu Lib "USER32" (ByVal hMenu As Long _
, ByVal nPosition As Long, ByVal wFlags As Long) As Long
Private Declare Function GetSystemMenu Lib "USER32" (ByVal hWnd As Long _
, ByVal bRevert As Long) As Long
Private Declare Function DrawMenuBar Lib "USER32" (ByVal hWnd As Long) As Long
'
Private Const MF_REMOVE& = &H1000&
Private Const MF_ENABLED& = &H0&
Private Const MF_INSERT& = &H0&
'
Private Const SC_CLOSE& = &HF060&
Private Const SC_MINIMIZE& = &HF020&
Private Const SC_MAXIMIZE& = &HF030&
Private Const SC_RESTORE& = &HF120&
'
'--- Screen saver: --------------------------------------------------------
Private Declare Function SystemParametersInfo Lib "USER32" Alias _
    "SystemParametersInfoA" (ByVal uAction As Long, ByVal uParam As Long, _
    lpvParam As Any, ByVal fuWinIni As Long) As Long
'
Private Const SPI_GETSCREENSAVEACTIVE& = 16
Private Const SPI_SETSCREENSAVEACTIVE& = 17
Public Function Sequenza1_2_5(ByVal ValI As Double, _
    Optional ByVal bMantissaInSeq As Boolean = False, _
    Optional ByVal ValMax As Double = 1E+300) As Double
'
'   Ritorna il prossimo valore nella sequenza ... -> 1 -> 2 -> 5 -> 10 -> ...
'   Se bMantissaInSeq = True e ValI e' gia' uno dei numeri della sequenza
'   ritorna lo stesso ValI; se ValI <= 0 ritorna 1.  Il valore massimo
'   della sequenza e' limitato al valore ValMax:
'
    Dim ValE$, rrM#, rrE#, Seq1_2_5#
'
    ValE$ = Format$(ValI, "0.000000E+000")
    rrM = CDbl(Left$(ValE$, 8))
    rrE = CDbl("1" & Right$(ValE$, 5))
'
    Seq1_2_5 = 1
'
    If bMantissaInSeq And ((rrM = 1) Or (rrM = 2) Or (rrM = 5)) Then
       Seq1_2_5 = ValI
'
    ElseIf (1 <= rrM) And (rrM < 2) Then
        Seq1_2_5 = 2 * rrE
    ElseIf (2 <= rrM) And (rrM < 5) Then
        Seq1_2_5 = 5 * rrE
    ElseIf (5 <= rrM) And (rrM < 10) Then
        Seq1_2_5 = 10 * rrE
    End If
'
    If (Seq1_2_5 <= ValMax) Then
        Sequenza1_2_5 = Seq1_2_5
    Else
        Sequenza1_2_5 = ValMax
    End If
'
'
'
End Function
Public Function Sequenza5_2_1(ByVal ValI As Double, _
    Optional ByVal bMantissaInSeq As Boolean = False, _
    Optional ByVal ValMin As Double = 0#) As Double
'
'   Ritorna il prossimo valore nella sequenza ... -> 10 -> 5 -> 2 -> 1 -> ...
'   Se bMantissaInSeq = True e ValI e' gia' uno dei numeri della sequenza
'   ritorna lo stesso ValI; se ValI <= ValMin ritorna ValMin:
'
    Dim ValE$, rrM#, rrE#, Seq5_2_1
'
    ValE$ = Format$(ValI, "0.000000E+000")
    rrM = CDbl(Left$(ValE$, 8))
    rrE = CDbl("1" & Right$(ValE$, 5))
'
    Seq5_2_1 = 0
'
    If bMantissaInSeq And ((rrM = 1) Or (rrM = 2) Or (rrM = 5)) Then
       Seq5_2_1 = ValI
'
    ElseIf (1 < rrM) And (rrM <= 2) Then
        Seq5_2_1 = 1 * rrE
    ElseIf (2 < rrM) And (rrM <= 5) Then
        Seq5_2_1 = 2 * rrE
    ElseIf (5 < rrM) And (rrM <= 10) Then
        Seq5_2_1 = 5 * rrE
    ElseIf (rrM = 1) Then
        Seq5_2_1 = 0.5 * rrE
    End If
'
    If (ValMin <= Seq5_2_1) Then
        Sequenza5_2_1 = Seq5_2_1
    Else
        Sequenza5_2_1 = ValMin
    End If
'
'
'
End Function
Public Function MODULO(Aa As Double, PP As Double) As Double
'
'   Implementa la funzione MODULO(a, p) del FORTRAN:
'
    MODULO = Aa - Int(Aa / PP) * PP
'
'
'
End Function
Public Function GetIniString(ByVal FileINI$, ByVal Section$, ByVal Key$, _
    Optional ByVal DefaultString$) As String
'
'
    Dim BUF$, E&
    Const LBF& = 255
'
    On Error GoTo GetIniString_ERR
'
    BUF$ = Space$(LBF)
'
    E = GetPrivateProfileString(Section$, Key$, DefaultString$, BUF$, LBF, FileINI$)
    GetIniString = Left$(BUF$, E)
'
'
GetIniString_ERR:
    If (Err.Number <> 0) Then
        Dim M$
        M$ = "Sezione [" & Section$ & "] nel File " & FileINI$ & vbNewLine
        M$ = M$ & "non esistente o di formato non valido." & vbNewLine
        M$ = M$ & vbNewLine & vbNewLine
        M$ = M$ & "Errore " & Str$(Err.Number) & vbNewLine
        M$ = M$ & Err.Description
        MsgBox M$, vbCritical, " modUtilita: GetIniString"
'
        GetIniString = ""
    End If
'
'
'
End Function
Public Function SaveIniString(ByVal FileINI$, ByVal Section$, ByVal Key$, _
    ByVal StringToAdd$) As Boolean
'
'
    Dim lRet&
'
    On Error GoTo SaveIniString_ERR
'
    lRet = WritePrivateProfileString(Section$, Key$, StringToAdd$, FileINI$)
    If (lRet = 0) Then
        Err.Raise 1001, , "WritePrivateProfileString - Err: " & Str$(lRet)
    End If
'
'
SaveIniString_ERR:
    SaveIniString = (Err.Number = 0)
    If (Err.Number <> 0) Then
        Dim M$
        M$ = "Il programma ha trovato una condizione inattesa." & vbNewLine & vbNewLine
        M$ = M$ & "Errore " & Str$(Err.Number) & vbNewLine
        M$ = M$ & Err.Description
        MsgBox M$, vbCritical, " modUtilita: SaveIniString"
    End If
'
'
'
End Function
Public Sub LeggiPosizioneFormINI(ByVal FileINI$, ByVal frmF As Form, _
    ByRef frmF_Left As Long, ByRef frmF_Top As Long, _
    Optional ByRef frmF_Width As Long, Optional ByRef frmF_Height As Long, _
    Optional ByVal bFullScreen As Boolean = False)
'
'   Legge la posizione iniziale [e le dimensioni] del Form frmF memorizzate
'   sul file FileINI$.  bFullScreen, se True, indica che per default il Form
'   deve essere posizionato e dimensionato a pieno schermo.
'
'   Da usare nell' evento frmF_Load:
'
    If FileExists(FileINI$) Then
        frmF_Left = GetIniString(FileINI$, "Posizione Forms:", _
                                 frmF.Name & "_Left", _
                                 IIf(bFullScreen, 0, RandU(5, 4500)))
        frmF_Top = GetIniString(FileINI$, "Posizione Forms:", _
                                 frmF.Name & "_Top", _
                                 IIf(bFullScreen, 0, RandU(5, 4500)))
'
        frmF_Width = GetIniString(FileINI$, "Posizione Forms:", _
                                  frmF.Name & "_Width", _
                                  IIf(bFullScreen, Screen.Width, frmF.Width))
        frmF_Height = GetIniString(FileINI$, "Posizione Forms:", _
                                   frmF.Name & "_Height", _
                                   IIf(bFullScreen, Screen.Height, frmF.Height))
    Else
        frmF_Left = IIf(bFullScreen, 0, RandU(5, 4500))
        frmF_Top = IIf(bFullScreen, 0, RandU(5, 4500))
'
        frmF_Width = IIf(bFullScreen, Screen.Width, frmF.Width)
        frmF_Height = IIf(bFullScreen, Screen.Height, frmF.Height)
    End If
'
    If ((Screen.Width - 4) < frmF_Width) Then frmF_Width = Screen.Width - 4
    If ((Screen.Height - 4) < frmF_Height) Then frmF_Height = Screen.Height - 4
'
'
'
End Sub
Public Sub SalvaPosizioneFormINI(ByVal FileINI$, ByVal frmF As Form, _
    Optional ByVal bDimensioni As Boolean = False)
'
'   Salva, sul file FileINI$ la posizione finale del Form frmF.
'   Da usare nell' evento frmF_Unload.
'   Se Dimensioni = True salva anche le dimensioni:
'
    Dim frmName$
'
    frmName$ = frmF.Name
'
    If (frmF.WindowState <> vbMinimized) Then
        SaveIniString FileINI$, "Posizione Forms:", frmName$ & "_Left", frmF.Left
        SaveIniString FileINI$, "Posizione Forms:", frmName$ & "_Top", frmF.Top
'
        If bDimensioni Then
            SaveIniString FileINI$, "Posizione Forms:", frmName$ & "_Width", frmF.Width
            SaveIniString FileINI$, "Posizione Forms:", frmName$ & "_Height", frmF.Height
        End If
    End If
'
'
'
End Sub
Public Function ValC2D(ByVal sNum$) As String
'
'   Sostituisce, nella stringa numerica sNum$,
'   la "," con il ".".  Rende cosi' possibile
'   usare la funzione Val su testi che usino la
'   "," come separatore decimale.
'
    ValC2D = Replace(sNum$, ",", ".")
'
'
'
End Function
Public Function DMAX1(ParamArray vD() As Variant) As Double
'
'   Implementa la funzione DMAX1(D1, D2, ...DN) del FORTRAN:
'
    Dim J&, J1&, J2&, vDMax As Variant
'
    J1 = LBound(vD)
    J2 = UBound(vD)
    vDMax = vD(J1)
    For J = J1 + 1 To J2
        If (vDMax < vD(J)) Then vDMax = vD(J)
    Next J
'
    DMAX1 = CDbl(vDMax)
'
'
'
End Function
Public Function DMIN1(ParamArray vD() As Variant) As Double
'
'   Implementa la funzione DMIN1(D1, D2, ...DN) del FORTRAN:
'
    Dim J&, J1&, J2&, vDMin As Variant
'
    J1 = LBound(vD)
    J2 = UBound(vD)
    vDMin = vD(J1)
    For J = J1 + 1 To J2
        If (vD(J) < vDMin) Then vDMin = vD(J)
    Next J
'
    DMIN1 = CDbl(vDMin)
'
'
'
End Function
Public Function DATAN2(ByVal Y As Double, ByVal X As Double) As Double
'
'   Ritorna il Valore dell' ArcoTangente di y/x
'   come implementata dal FORTRAN.
'   E':    -PI < DATAN2 <= PI.
'
    Select Case X
        Case Is > 0#
        DATAN2 = Atn(Y / X)
'
        Case Is < 0#
        If Y >= 0# Then
            DATAN2 = Atn(Y / X) + PI
        ElseIf (Y < 0#) Then
            DATAN2 = Atn(Y / X) - PI
        End If
'
        Case Is = 0#
        DATAN2 = Sgn(Y) * PI / 2#
    End Select
'
'
'
End Function
Public Function ScreenSaver(ByVal bAbilita As Boolean) As Boolean
'
'   Abilita o disabilita lo ScreenSaver.  La funzione
'   ritorna lo stato dello ScreenSaver prima dell' azione
'   richiesta per poterlo poi, eventualmente, ripristinare.
'
'   Da: MSDN Tip 43: Activating and Deactivating the Screen Saver.
'   e:  How to Disable the Screen Saver Programmatically. Article ID: Q126627
'
    Dim Stato&
'
    ' Legge lo stato corrente dello ScreenSaver:
    SystemParametersInfo SPI_GETSCREENSAVEACTIVE, 0, Stato, 0
    ScreenSaver = CBool(Stato)
'
    ' Imposta lo stato voluto:
    Stato = CLng(bAbilita)
    SystemParametersInfo SPI_SETSCREENSAVEACTIVE, Stato, 0, 0
'
'
'
End Function
Public Function HexToDec(ByVal HexVal$, Optional ByVal Comp2 As Boolean = False) As Long
'
'   Converte la stringa esadecimale HexVal$ nel suo
'   corrispondente valore decimale.
'   La variabile Comp2 indica come si deve gestire
'   il complemento a due su HexVal$ di 4 Bytes.
'   E.g.:
'    Se Comp2$ = True,  HexVal$ = "FFFF" ritorna -1.
'    Se Comp2$ = False, HexVal$ = "FFFF" ritorna 65535.
'
    If Comp2 Then
        HexToDec = Val("&H" & HexVal$)
    Else
        HexToDec = Val("&H" & HexVal$ & "&")
    End If
    
'
'
'
End Function
Public Function Quadro(ByVal objFoglio As Object, _
    ByVal X0 As Double, ByVal Y0 As Double, ByVal Xn As Double, ByVal Yn As Double, _
    Optional ByVal FormatVX$ = "#0.0##", Optional ByVal FormatVY$ = "#0.0##", _
    Optional ByVal bMaPrX As Boolean = False, Optional ByVal bMaPrY As Boolean = False, _
    Optional ByVal Npx As Long = 1, _
    Optional ByRef PxN_X As Single, Optional ByRef PxN_Y As Single, _
    Optional ByVal Titolo$ = "", _
    Optional ByVal UnitaX$ = "", Optional ByVal UnitaY$ = "", _
    Optional ByVal bAutoRed As Boolean = False, _
    Optional ByVal bAutoScX As Boolean = True, _
    Optional ByVal bAutoScY As Boolean = True, _
    Optional ByRef SxMin As Single, Optional ByRef SyMin As Single, _
    Optional ByRef SxMax As Single, Optional ByRef SyMax As Single, _
    Optional ByRef QxMin As Single, Optional ByRef QyMin As Single, _
    Optional ByRef QxMax As Single, Optional ByRef QyMax As Single, _
    Optional ByVal ColRif As Long = vbGreen, Optional ByVal ColFgl As Long = vbBlack, _
    Optional ByVal ColTit As Long = vbRed, _
    Optional ByVal bGriglia As Boolean = True, _
    Optional ByVal Font$ = "MS Sans Serif", _
    Optional ByRef UnitaX_x As Single, Optional ByRef UnitaX_y As Single, _
    Optional ByRef UnitaY_x As Single, Optional ByRef UnitaY_y As Single) As Boolean
'
'   Routine, di uso generale, per la scalatura di un foglio
'   adatto a rappresentare un grafico y = f(x).
'
'    Parametri in ingresso:
'     objFoglio: Form o PictureBox da scalare.
'     X0:        valore minimo di ascissa da rappresentare.
'     Y0:        valore minimo di ordinata da rappresentare.
'     Xn:        valore massimo di ascissa da rappresentare.
'                Deve essere X0 <= Xn.
'     Yn:        valore massimo di ordinata da rappresentare.
'                Deve essere Y0 <= Yn.
'     FormatVX$: stringa di formato dei valori sull' asse X.
'     FormatVY$: stringa di formato dei valori sull' asse Y.
'                Se la stringa di formato e' " ", i rispettivi
'                valori di X o Y non vengono scritti.
'     bMaPrX:    se True i ripettivi valori degli assi X e Y vengono scritti
'     bMaPrY:    (se richiesti) in formato Mantissa + Prefisso; se questi
'                flags sono usati, le rispettive stringhe di formato devono
'                seguire le regole date in Sub FormatPrf.
'     Npx:       N di Pixels di cui si vuole conoscere
'                larghezza ed altezza in [vbUser].
'     Titolo$:   titolo del grafico.
'     UnitaX$:   unita' (o titolo) dell' asse X.
'     UnitaY$:   unita' (o titolo) dell' asse Y.
'     bAutoRed:  stato di objFoglio.AutoRedraw dopo il disegno del quadro.
'     bAutoScX:  se True la spaziatura dell' asse X viene calcolata in
'                sequenza 1, 2, 2.5 e 5; se False viene usato l' intervallo
'                X0 - Xn diviso in 10 parti.
'     bAutoScY:  come bAutoScX ma per l' asse Y.
'     ColRif:    colore degli assi, dei valori e delle griglie di riferimento.
'     ColFgl:    colore di sfondo di objFoglio.
'     ColTit:    colore del titolo.
'     bGriglia:  se True viene disegnata la griglia di riferimento;
'                se False viene fatta solo la scalatura di objFoglio.
'     Font$:     Font dei valori sugli assi e del titolo.
'
'    Parametri in uscita:
'     SxMin:     valore minimo di ascissa della griglia di riferimento.
'     SyMin:     valore minimo di ordinata  "      "    "      "
'     SxMax:     valore massimo di ascissa  "      "    "      "
'     SyMax:     valore massimo di ordinata "      "    "      "
'     QxMin:     valore minimo di ascissa del quadro.
'     QyMin:     valore minimo di ordinata del quadro.
'     QxMax:     valore massimo di ascissa del quadro.
'     QyMax:     valore massimo di ordinata del quadro.
'     PxN_X:     larghezza in [vbUser] ed
'     PxN_Y:     altezza in [vbUser] di Npx Pixels.
'     UnitaX_x:  coordinate _x e _y di scrittura
'     UnitaX_y:  delle unita' di misura degli assi
'     UnitaY_x:  per poter usare, da routine chiamante,
'     UnitaY_y:  il Font desiderato (e.g. Symbol).
'
'    Funzioni esterne richieste:
'     Ceil, FormatPrf, Log10.
'
'   Rev. 26/08/2006.
'   Rev. 21/10/2006.
'   Rev. 29/04/2007.
'   Rev. 17/02/2008.
'   Rev. 05/05/2008.
'   Rev. 01/07/2008.
'   Rev. 05/01/2009.
'
    Dim I&, XI#, D_X#, rrx#, YI#, D_Y#, rry#
    Dim Txt$, TW!, TxtSx!, TxtDx!, TxtDxU!, Mantissa$, Prefisso$
'
    On Error GoTo Quadro_ERR
'
    ' Verifico la correttezza delle scale:
    If (Xn < X0) Then Err.Raise 1001, "Quadro", "Errore di scala X."
    If (Yn < Y0) Then Err.Raise 1001, "Quadro", "Errore di scala Y."
'
'-- Calcolo il passo di grigliatura degli assi. ----------------------------------------
'
    Dim DYMin#
    'Const ScRis& = 3                ' La risoluzione delle scale e' 10 ^ -ScRis (default).
    Const ScRis& = 9                ' La risoluzione delle scale e' 10 ^ -ScRis (per AudioCardDSP).
    Const ScMin# = 10 ^ (1 - ScRis) ' Ampiezza min. delle scale X e Y.
'
    ' Imposto una scala minima
    ' per l' asse X:
    If ((Xn - X0) < ScMin) Then
        X0 = X0 - ScMin / 2#
        Xn = Xn + ScMin / 2#
    End If
'
    If bAutoScX Then
        ' Calcolo la spaziatura dei valori scritti
        ' sull' asse X: la sequenza e' 1, 2, 2.5 e 5:
        D_X = Xn - X0
        rrx = 10# ^ Ceil(Log(D_X / 20#) / Log10)
        Do While D_X / rrx < 5#
            rrx = rrx / 2#
        Loop
        If (10# < (D_X / rrx)) Then rrx = rrx * 2#
        X0 = rrx * Int(Round(X0 / rrx, ScRis))
        Xn = rrx * Ceil(Round(Xn / rrx, ScRis))
        D_X = Xn - X0
        SxMin = X0
        SxMax = Xn
'
    Else
        D_X = Xn - X0
        rrx = D_X / 10#
        SxMin = X0
        SxMax = Xn
    End If
'
    ' Imposto una scala minima
    ' per l' asse Y:
    If (FormatVY$ <> " ") Then
        If (Format$(Y0, FormatVY$) = Format$(Yn, FormatVY$)) Then
            DYMin = 0.0001
            Do While Format$(Y0 - DYMin, FormatVY$) = Format$(Yn + DYMin, FormatVY$)
                DYMin = 2# * DYMin
            Loop
'
            Y0 = Y0 - 10# * DYMin
            Yn = Yn + 10# * DYMin
        End If
'
    Else
        If ((Yn - Y0) < ScMin) Then
            Y0 = Y0 - ScMin / 2#
            Yn = Yn + ScMin / 2#
        End If
    End If
'
    If bAutoScY Then
        ' Calcolo la spaziatura dei valori scritti
        ' sull' asse Y: la sequenza e' 1, 2, 2.5 e 5:
        D_Y = Yn - Y0
        rry = 10# ^ Ceil(Log(D_Y / 20#) / Log10)
        Do While D_Y / rry < 5#
            rry = rry / 2#
        Loop
        If (10# < (D_Y / rry)) Then rry = rry * 2#
        Y0 = rry * Int(Round(Y0 / rry, ScRis))
        Yn = rry * Ceil(Round(Yn / rry, ScRis))
        D_Y = Yn - Y0
        SyMin = Y0
        SyMax = Yn
'
    Else
        D_Y = Yn - Y0
        rry = D_Y / 10#
        SyMin = Y0
        SyMax = Yn
    End If
'
'-- Calcolo larghezza ed altezza dei margini. ------------------------------------------
'
    Dim Bl!, Br!, Bb!, Bt!, BDen!
    Dim TxWs!, TxWd!, TxHt!, TxHb!
'
    ' Imposto i dati di Font dei valori
    ' degli assi:
    objFoglio.FontName = Font$
    objFoglio.FontSize = 8
    objFoglio.FontBold = False
'
    ' Annullo le scale precedenti:
    objFoglio.ScaleMode = vbPixels
'
    ' Il margine a sinistra deve essere sufficiente
    ' a contenere il valore Y piu' largo:
    If (FormatVY$ <> " ") Then
        If bMaPrY Then
            FormatPrf Y0, Mantissa$, Prefisso$, FormatVY$
            Txt$ = Mantissa$ & Prefisso$ & "W"
        Else
            Txt$ = Format$(Y0, FormatVY$) & "W"
        End If
        TxWs = objFoglio.TextWidth(Txt$)
'
        If bMaPrY Then
            FormatPrf Yn, Mantissa$, Prefisso$, FormatVY$
            Txt$ = Mantissa$ & Prefisso$ & "W"
        Else
            Txt$ = Format$(Yn, FormatVY$) & "W"
        End If
        If (TxWs < objFoglio.TextWidth(Txt$)) Then
            TxWs = objFoglio.TextWidth(Txt$)
        End If
'
    Else
        TxWs = objFoglio.TextWidth("WWW")
    End If
'
    ' Il margine a destra deve essere sufficiente
    ' a contenere il valore Xn e l' etichetta UnitaX$:
    If (FormatVX$ <> " ") Then
        If bMaPrX Then
            FormatPrf Xn, Mantissa$, Prefisso$, FormatVX$
            Txt$ = Mantissa$ & Prefisso$
        Else
            Txt$ = Format$(Xn, FormatVX$)
        End If
        TxWd = (objFoglio.TextWidth(Txt$) / 2!) _
             + objFoglio.TextWidth(UnitaX$ & "W")
'
    Else
        TxWd = objFoglio.TextWidth(UnitaX$ & "W")
    End If
'
    ' I margini a sinistra ed a destra sono:
    BDen = D_X / (objFoglio.ScaleWidth - TxWs - TxWd)
    Bl = TxWs * BDen
    Br = TxWd * BDen
'
    ' Il margine sotto e' 3 volte l' altezza dei valori:
    TxHb = 3! * Abs(objFoglio.TextHeight("H"))
'
    ' Il margine sopra e' 2 volte l' altezza dei valori
    ' piu' l' altezza del titolo:
    objFoglio.FontSize = 12
    TxHt = TxHb + Abs(objFoglio.TextHeight(Titolo$))
'
    ' I margini sopra e sotto sono:
    BDen = D_Y / (Abs(objFoglio.ScaleHeight) + TxHb + TxHt)
    Bb = TxHb * BDen
    Bt = TxHt * BDen
'
'-- Imposto la scala e calcolo i valori comuni. ----------------------------------------
'
    ' Imposto i bordi orizzontali
    ' e verticali:
    QxMin = X0 - Bl
    QxMax = X0 + D_X + Br
    QyMin = Y0 - Bb
    QyMax = Y0 + D_Y + Bt
'
    ' Imposto la scala di objFoglio:
    objFoglio.Scale (QxMin, QyMax)-(QxMax, QyMin)
'
    ' Calcolo larghezza ed altezza di Npx pixels:
    PxN_X = Abs(objFoglio.ScaleX(Npx, vbPixels, vbUser))
    PxN_Y = Abs(objFoglio.ScaleY(Npx, vbPixels, vbUser))
'
    ' Verifico se e' richiesto il
    ' disegno della griglia:
    If (Not bGriglia) Then GoTo Fine
'
'-- Disegno assi, griglie e scrivo i valori di scala. ----------------------------------
'
    Dim Po4_X!, Po4_Y!, EstAx!, EstAy!
'
    ' La griglia deve essere permanente:
    objFoglio.AutoRedraw = True
'
    objFoglio.Picture = LoadPicture()
    objFoglio.BackColor = ColFgl
'
    ' Calcolo larghezza ed altezza di 4 points:
    Po4_X = objFoglio.ScaleX(4, vbPoints, vbUser)   ' Uso i [Points] perche' voglio dimensioni
    Po4_Y = objFoglio.ScaleY(4, vbPoints, vbUser)   ' proporzionali a quelle dei caratteri.
'
    ' Estremita' degli assi X e Y:
    EstAx = (Xn + QxMax) / 2!
    EstAy = (Yn + QyMax) / 2!
'
    objFoglio.FontSize = 8
    objFoglio.DrawWidth = 1
    objFoglio.DrawMode = vbCopyPen
    objFoglio.ForeColor = ColRif
'
    ' Traccio la griglia verticale:
    objFoglio.DrawStyle = vbDash
    For XI = X0 To Xn + 0.1 * rrx Step rrx
        objFoglio.Line (XI, Y0)-(XI, Yn), ColRif
    Next XI
'
    ' Scrivo i valori dell' asse X:
    UnitaX_y = Y0 + Po4_Y / 2!
    objFoglio.CurrentY = UnitaX_y
    If (FormatVX$ <> " ") Then
        ' Scrivo il valor minimo:
        If bMaPrX Then
            FormatPrf X0, Mantissa$, Prefisso$, FormatVX$
            Txt$ = " " & Mantissa$ & Prefisso$ & " "
        Else
            Txt$ = " " & Format$(X0, FormatVX$) & " "
        End If
        TW = objFoglio.TextWidth(Txt$)
        TxtDx = X0 + TW / 2!
        objFoglio.CurrentX = X0 - TW / 2!
        objFoglio.Print Txt$;
'
        ' Scrivo il valor massimo:
        If bMaPrX Then
            FormatPrf Xn, Mantissa$, Prefisso$, FormatVX$
            Txt$ = " " & Mantissa$ & Prefisso$ & " "
        Else
            Txt$ = " " & Format$(Xn, FormatVX$) & " "
        End If
        TW = objFoglio.TextWidth(Txt$)
        TxtSx = Xn - TW / 2!
        objFoglio.CurrentX = TxtSx
        objFoglio.Print Txt$;
        TxtDxU = objFoglio.CurrentX
'
        For XI = X0 + rrx To Xn - rrx + 0.1 * rrx Step rrx
            If bMaPrX Then
                FormatPrf XI, Mantissa$, Prefisso$, FormatVX$
                Txt$ = " " & Mantissa$ & Prefisso$ & " "
            Else
                Txt$ = " " & Format$(XI, FormatVX$) & " "
            End If
            ' Verifico che il formato scelto non
            ' induca ad errori di rappresentazione
            ' e che le etichette non si sovrappongano:
            TW = objFoglio.TextWidth(Txt$) / 2!
            If (Abs(XI - CDbl(Format$(XI, FormatVX$))) < (rrx / 10#)) _
            And (TxtDx < (XI - TW)) And ((XI + TW) < TxtSx) Then
                TxtDx = XI + TW
                objFoglio.CurrentX = XI - TW
                objFoglio.Print Txt$;
            End If
        Next XI
    End If
'
    ' Traccio l' asse Y:
    If (X0 <= 0#) And (0# <= Xn) Then
        objFoglio.DrawStyle = vbSolid
        objFoglio.Line (0!, Y0)-(0!, EstAy), ColRif
        objFoglio.Line (0!, EstAy)-(-Po4_X / 2!, Po4_Y + EstAy), ColRif
        objFoglio.Line (0!, EstAy)-(Po4_X / 2!, Po4_Y + EstAy), ColRif
    End If
'
    ' Traccio la griglia orizzontale:
    objFoglio.DrawStyle = vbDash
    For YI = Y0 To Yn + 0.1 * rry Step rry
        objFoglio.Line (X0, YI)-(Xn, YI), ColRif
    Next YI
'
    ' Scrivo i valori dell' asse Y:
    If (FormatVY$ <> " ") Then
        For YI = Y0 To Yn + 0.1 * rry Step rry
            objFoglio.Line (X0, YI)-(Xn, YI), ColRif
            If bMaPrY Then
                FormatPrf YI, Mantissa$, Prefisso$, FormatVY$
                Txt$ = " " & Mantissa$ & Prefisso$ & " "
            Else
                Txt$ = " " & Format$(YI, FormatVY$) & " "
            End If
            ' Verifico che il formato scelto non
            ' induca ad errori di rappresentazione:
            If (Abs(YI - CDbl(Format$(YI, FormatVY$))) < (rry / 10#)) Then
                objFoglio.CurrentX = QxMin
                objFoglio.CurrentY = YI - objFoglio.TextHeight(Txt$) / 2!
                objFoglio.Print Txt$;
            End If
        Next YI
    End If
'
    ' Traccio l' asse X:
    If (Y0 <= 0#) And (0# <= Yn) Then
        objFoglio.DrawStyle = vbSolid
        objFoglio.Line (X0, 0!)-(EstAx, 0!), ColRif
        objFoglio.Line (EstAx, 0!)-(EstAx - Po4_X, -Po4_Y / 2!), ColRif
        objFoglio.Line (EstAx, 0!)-(EstAx - Po4_X, Po4_Y / 2!), ColRif
    End If
'
'-- Scrivo il titolo del grafico: ------------------------------------------------------
'
    Dim TitL!, TitT!, TitW!, TitH!, TitoloR$
'
    If (0 < Len(Titolo$)) Then
        objFoglio.FontSize = 12
        objFoglio.FontBold = True
        objFoglio.ForeColor = ColTit
'
        TitoloR$ = Titolo$
        TitW = objFoglio.TextWidth(TitoloR$)
        TitH = objFoglio.TextHeight(TitoloR$)
'
        ' Verifico che il titolo stia tutto
        ' nella larghezza del grafico ...:
        If (TitW <= (Xn - X0)) Then
            TitL = (Xn + X0 - TitW) / 2!
'
        Else
            ' ... e se no lo taglio:
            TitL = X0
            Txt$ = " . . ."
            TitoloR$ = Left$(Titolo$, Int(Len(TitoloR$) _
                          * (Xn - X0 - objFoglio.TextWidth(Txt$)) / TitW))
            If (TitoloR$ <> Titolo$) Then TitoloR$ = TitoloR$ & Txt$
        End If
'
        TitT = QyMax
        ' Cancello l' area su cui andra' scritto il titolo:
        'objFoglio.Line (TitL, TitT)-(TitL + TitW, TitT + TitH), objFoglio.BackColor, BF
        objFoglio.CurrentX = TitL
        objFoglio.CurrentY = TitT
        objFoglio.Print TitoloR$
    End If
'
'-- Scrivo le unita' degli assi: -------------------------------------------------------
'
    objFoglio.FontSize = 8
    objFoglio.FontBold = False
    objFoglio.ForeColor = ColRif
'
    ' Scrivo l' etichetta dell' asse X:
    ' Etichetta tutta a destra:
    'UnitaX_x = QxMax - objFoglio.TextWidth(UnitaX$ & " ")
    ' Etichetta in centro tra l' ultimo valore ed il bordo a destra:
    UnitaX_x = (TxtDxU + QxMax - objFoglio.TextWidth(UnitaX$)) / 2!
'
    objFoglio.CurrentX = UnitaX_x
    objFoglio.CurrentY = UnitaX_y
    objFoglio.Print UnitaX$;
'
    ' Scrivo l' etichetta dell' asse Y:
    UnitaY_x = QxMin + objFoglio.TextWidth("O")
    UnitaY_y = QyMax + objFoglio.TextHeight("O") / 3
'
    objFoglio.CurrentX = UnitaY_x
    objFoglio.CurrentY = UnitaY_y
    objFoglio.Print UnitaY$;
'
Fine:
    objFoglio.DrawStyle = vbSolid
    objFoglio.AutoRedraw = bAutoRed
'
'
Quadro_ERR:
    Quadro = (Err.Number = 0)
    If (Err.Number <> 0) Then
        Dim M$
        M$ = "Errore " & Str$(Err.Number) & vbNewLine
        M$ = M$ & Err.Description
        MsgBox M$, vbCritical, " modUtilita: Quadro"
    End If
'
'
'
End Function
Public Sub ScrivoCome(ByVal ctrFoglio As Control, ByVal Font$, ByVal Size As Long, _
    Optional ByVal bBold As Boolean = False, Optional ByVal Colore& = vbBlack)
'
'   Imposta le proprieta' di scrittura
'   sul controllo ctrFoglio:
'
    On Error GoTo ScrivoCome_ERR
'
    ctrFoglio.FontName = Font$
    ctrFoglio.FontSize = Size
    ctrFoglio.FontBold = bBold
    ctrFoglio.ForeColor = Colore
'
'
ScrivoCome_ERR:
    If (Err.Number <> 0) Then
        Dim M$
        M$ = "Il controllo " & ctrFoglio.Name & vbNewLine
        M$ = M$ & "non espone le proprieta' richieste." & vbNewLine & vbNewLine
        M$ = M$ & "Errore " & Str$(Err.Number) & vbNewLine
        M$ = M$ & Err.Description
        MsgBox M$, vbCritical, " modUtilita: ScrivoCome"
    End If
'
'
'
End Sub
Public Sub FormatPrf(ByVal vNum As Variant, _
    Optional ByRef Mantissa$, Optional ByRef Prefisso$, _
    Optional ByVal strF$ = "0.000E+00", Optional ByRef nEsp As Long)
'
'   Trasforma il valore vNum in formato SI con mantissa e prefisso,
'   i.e. micro (), milli (m), ..., kilo (k), etc... conservando il
'   numero di cifre della mantissa di strF$; ritorna anche il valore
'   nEsp che e' la potenza di 10 corrispondente al prefisso.
'   La stringa di formato strF$ deve definire un formato scientifico
'   ed essere costruita come "0.00[0[0[...]]]E+0[0[0]]" in cui:
'   - la mantissa deve avere solo uno 0 a sinistra del punto decimale
'     ed almeno due zeri (e solo zeri) a destra.
'   - l' esponente deve essere "E+0[0[0]]".
'
'   Nota: accertarsi che il Font usato per scrivere il Prefisso$
'         contenga il carattere "".
'
'   Rev. 17/06/2007.
'   Rev. 06/12/2008.
'
    Dim FTemp$, Mant$, esp$, EPos&, NCifre&, MEsp&
'
    strF$ = UCase$(strF$)
    EPos = InStr(strF$, "E")
    NCifre = EPos - 1
'
    Mant$ = Left$(strF$, NCifre)
    esp$ = Mid$(strF$, EPos)
'
    MEsp = Val(Mid$(Format$(Abs(vNum), strF$), EPos + 1)) Mod 3 ' -2 <= MEsp <= +2.
'
    If (0 < MEsp) Then
        Mant$ = Left$(String$(MEsp, "0") & Mant$, NCifre)
    ElseIf (MEsp < 0) Then
        Mant$ = Left$(String$(3 + MEsp, "0") & Mant$, NCifre)
    End If
'
    FTemp$ = Format$(vNum, Mant$ & esp$)
    EPos = InStr(FTemp$, "E")   ' Da ritrovare, perche' vNum potrebbe essere negativo.
'
    Mantissa$ = Left$(FTemp$, EPos - 1)
'
    nEsp = Val(Mid$(FTemp$, EPos + 1))
'
    Select Case nEsp
    Case -18
        Prefisso$ = "a" ' (atto).
    Case -15
        Prefisso$ = "f" ' (femto).
    Case -12
        Prefisso$ = "p" ' (pico).
    Case -9
        Prefisso$ = "n" ' (nano).
    Case -6
        Prefisso$ = "" ' (micro).
    Case -3
        Prefisso$ = "m" ' (milli).
    Case 0
        Prefisso$ = ""
    Case 3
        Prefisso$ = "k" ' (kilo).
    Case 6
        Prefisso$ = "M" ' (mega).
    Case 9
        Prefisso$ = "G" ' (giga).
    Case 12
        Prefisso$ = "T" ' (tera).
    Case 15
        Prefisso$ = "P" ' (peta).
    Case 18
        Prefisso$ = "E" ' (eka).
'
    Case Else
        Prefisso$ = "E" & nEsp  ' non lo so' :-)).
    End Select
'
'
'
End Sub
Public Function LinTodB(ByVal Y As Double) As Double
'
'   Trasforma, sull' asse Y, una posizione da Lineare a Logaritmica.
'   LinTodB(1) = 0 [dB],  LinTodB(0.1) = -20 [dB]
'
    If (0# < Y) Then
        LinTodB = 20# * Log(Y) / Log10
    Else
        LinTodB = -9999#
    End If
'
'
'
End Function
Public Function LinToLog(ByVal X As Double, Optional ByVal BASE As Double = 10#) As Double
'
'   Trasforma una posizione da Lineare a Logaritmica.
'
    If (0# < X) Then
        LinToLog = Log(X) / Log(BASE)
    Else
        LinToLog = -9999#
    End If
'
'
'
End Function
Public Function dBToLin(ByVal Y As Double) As Double
'
'   Trasforma, sull' asse Y, una posizione da Logaritmica a Lineare.
'   dBToLin(0 [dB]) = 1,  dBToLin(-20 [dB]) = 0.1
'
    dBToLin = 10# ^ (Y / 20#)
'
'
'
End Function
Public Function LogToLin(ByVal X As Double, Optional ByVal BASE As Double = 10#) As Double
'
'   Trasforma una posizione da Logaritmica a Lineare.
'
    LogToLin = BASE ^ X
'
'
'
End Function
Public Function MAX0(ParamArray vD() As Variant) As Long
'
'   Implementa la funzione MIN0(K1, K2, ...KN) del FORTRAN:
'
    Dim J&, J1&, J2&, vDMax As Variant
'
    J1 = LBound(vD)
    J2 = UBound(vD)
    vDMax = vD(J1)
    For J = J1 + 1 To J2
        If (vDMax < vD(J)) Then vDMax = vD(J)
    Next J
'
    MAX0 = CLng(vDMax)
'
'
'
End Function
Public Sub CloseButtonDisable(ByVal frmF As Form)
'
'
    Dim lRet&
'
    lRet = RemoveMenu(GetSystemMenu(frmF.hWnd, 0), SC_CLOSE, MF_REMOVE)
'
'
'
End Sub
Public Sub AggiornaFilesRecenti(ByVal mnuRecenti As Object, ByVal FileRec$, _
    Optional ByVal MAXFIL As Long = 5)
'
'   Aggiunge al menu mnuRecenti() il file FileRec$.
'   mnuRecenti e' una voce di menu, con indice:
'   mnuRecenti(0) e' il titolo, i files da memorizzare
'   iniziano dalla posizione mnuRecenti(1).
'   Se FileRec$ e' gia' presente lo sposta al primo posto.
'   MAXFIL e' il numero massimo di files recenti da ricordare:
'   puo' essere diverso a seconda dell' applicazione che usa
'   questa routine (0 < MAXFIL < 10).
'
    Dim I&, F&, FILN&
    Dim a$, NuovoFile As Boolean
'
    If FileRec$ = "" Then Exit Sub
'
    FILN = mnuRecenti.UBound
'
    NuovoFile = True
    For F = 1 To FILN
        a$ = mnuRecenti(F).Caption
        If UCase$(Right$(a$, Len(a$) - 3)) = UCase$(FileRec$) Then
            NuovoFile = False
            Exit For
        End If
    Next F
    If F > FILN Then F = FILN
'
    If (FILN < MAXFIL) And NuovoFile Then
        FILN = FILN + 1
        F = FILN
        Load mnuRecenti(FILN)
        mnuRecenti(FILN).Visible = True
    End If
'
    mnuRecenti(0).Visible = (FILN > 0)
'
    For I = F To 2 Step -1
        a$ = mnuRecenti(I - 1).Caption
        a$ = "&" & Trim$(Str$(I)) & " " & Right$(a$, Len(a$) - 3)
        mnuRecenti(I).Caption = a$
    Next I
'
    mnuRecenti(1).Caption = "&1 " & FileRec$
'
'
'
End Sub
Public Sub LeggiFilesRecenti(ByVal mnuRecenti As Object, ByVal Sezione$, _
    Optional ByVal MAXFIL As Long = 5, Optional ByVal VerificaFE As Boolean = True)
'
'   Legge i files recenti dal Registry di Windows e li aggiunge
'   al menu mnuRecenti(). Se VerificaFE = True verifica anche
'   l' esistenza dei files da aggiungere:
'
    Dim I&, FileRec$
'
    For I = MAXFIL To 1 Step -1
        FileRec$ = GetSetting(App.ProductName, Sezione$, Str$(I), "")
        If (FileRec$ <> "") Then
            If VerificaFE Then
                If FileExists(FileRec$) Then AggiornaFilesRecenti mnuRecenti, FileRec$
            Else
                AggiornaFilesRecenti mnuRecenti, FileRec$
            End If
        End If
    Next I
'
'
'
End Sub
Public Sub SalvaFilesRecenti(ByVal mnuRecenti As Object, ByVal Sezione$)
'
'   Salva i files recenti, contenuti nel menu mnuRecenti(),
'   nel Registry di Windows:
'
    Dim I&, FileRec$
'
    For I = 1 To mnuRecenti.UBound
        FileRec$ = mnuRecenti(I).Caption
        FileRec$ = Right$(FileRec$, Len(FileRec$) - 3)
        SaveSetting App.ProductName, Sezione$, Str$(I), FileRec$
    Next I
'
'
'
End Sub
Public Function MIN0(ParamArray vD() As Variant) As Long
'
'   Implementa la funzione MIN0(K1, K2, ...KN) del FORTRAN:
'
    Dim J&, J1&, J2&, vDMin As Variant
'
    J1 = LBound(vD)
    J2 = UBound(vD)
    vDMin = vD(J1)
    For J = J1 + 1 To J2
        If (vD(J) < vDMin) Then vDMin = vD(J)
    Next J
'
    MIN0 = CLng(vDMin)
'
'
'
End Function
Public Function KAscNumReali(ByVal KA As Integer, _
    Optional ByVal NEG As Boolean = False) As Integer
'
'   Ritorna solo i caratteri validi per un campo
'   contenente un numero reale (anche negativo se
'   viene passato il valore Neg = True).
'   Tutti gli altri caratteri vengono annullati.
'   Usa le impostazioni locali del separatore decimale.
'   Va' usato nella procedura KeyPress di TextB come:
'   KeyAscii = KAscNumReali(KeyAscii [, Neg])
'   Questa versione accetta anche numeri in notazione
'   scientifica.
'
    Dim KeyDecimal%, KeyMinus%, KeyE%
    Dim TextB As TextBox    ' Solo per TextBoxes.
    'Dim TextB As Control    ' Anche per Combo, etc...
    Dim SD$, SM$, myKeyDecimal%
'
    Const myKeyMinus% = 45      ' E' il valore effettivamente ritornato
                                ' alla pressione del -;
                                ' vbKeySubtract (= 109)  non funziona.
    GetLocale SD$, SM$          ' Trova le impostazioni locali dei
    myKeyDecimal% = Asc(SD$)    ' separatori decimale e delle migliaia.
'
    Set TextB = Screen.ActiveControl
'
    ' Filtro per il separatore decimale:
    If (InStr(TextB.Text, SD$) = 0 _
    And Not (TextB.SelStart = 0 And Left$(TextB.Text, 1) = "-")) _
    Or TextB.SelText = TextB.Text Then KeyDecimal = myKeyDecimal
'
    ' Filtro per il segno "-":
    If (Left$(TextB.Text, 1) <> "-" Or TextB.SelText = TextB.Text) _
    And NEG And TextB.SelStart = 0 Then KeyMinus = myKeyMinus
'
    ' Filtro per la notazione scientifica:
    If TextB.SelStart > 0 Then
        KA = Asc(UCase$(Chr$(KA)))
        If (InStr(TextB.Text, "E") = 0 _
        And Not (TextB.SelStart = 0 Or TextB.SelText = TextB.Text)) _
        And Mid$(TextB.Text, TextB.SelStart, 1) <> "-" Then KeyE = vbKeyE
'
        If Mid$(TextB.Text, TextB.SelStart, 1) = "E" Then KeyMinus = myKeyMinus
'
        If (InStr(TextB.Text, "E") > 0) _
        And (TextB.SelStart - InStr(TextB.Text, "E") >= 0) Then KeyDecimal = 0
    End If
'
    Select Case KA
        Case vbKey0 To vbKey9, KeyDecimal, KeyMinus, vbKeyBack, KeyE
        KAscNumReali = KA
'
        Case Else
        KAscNumReali = 0
    End Select
'
'
'
End Function
Private Sub GetLocale(ByRef DS$, Optional ByRef MS$)
'
'   Trova i separatori decimale e
'   delle migliaia del sistema:
'
    DS$ = "  "
    MS$ = "  "
'
    GetLocaleInfo GetThreadLocale(), LOCALE_SDECIMAL, DS$, Len(DS$)
    GetLocaleInfo GetThreadLocale(), LOCALE_STHOUSAND, MS$, Len(MS$)
'
    DS$ = Left$(DS$, 1)
    MS$ = Left$(MS$, 1)
'
'
'
End Sub
Public Function FormatE$(ByVal vNum As Variant, Optional ByVal strF$ = "0.0#####E-00")
'
'   Ritorna il valore vNum in formato scientifico
'   ingegneristico (i.e. con esponente multiplo di 3):
'
    Dim FTemp$, MEsp&
'
    strF$ = UCase$(strF$)
    If (Left$(strF$, 1) = "+") Or (Left$(strF$, 1) = "-") Then
        strF$ = Mid$(strF$, 2)
    End If
'
    FTemp$ = Format$(vNum, strF$)
    MEsp = Val(Mid$(FTemp$, InStr(FTemp$, "E") + 1)) Mod 3
'
    If (0 < MEsp) Then
        strF$ = String(MEsp, "#") & strF$
    ElseIf (MEsp < 0) Then
        strF$ = String(3 - Abs(MEsp), "#") & strF$
    End If
'
    FormatE$ = Format$(vNum, strF$)
'
'
'
End Function
Public Function Acos(ByVal X As Double) As Double
'
'   Calcola l' ArcoCoseno di x con -1 <= x <= 1.
'   Acos e' in radianti.
'
    If (0# < X) And (X <= 1#) Then
        Acos = Atn(Sqr(1# - X * X) / X)
'
    ElseIf (-1# <= X) And (X < 0#) Then
        Acos = PI + Atn(Sqr(1# - X * X) / X)
'
    ElseIf (X = 0#) Then
        Acos = PI / 2#
'
    Else
        Err.Raise 5, "Acos Function", "Argomento illegale per Acos"
    End If
'
'
'
End Function
Public Function Asin(ByVal X As Double) As Double
'
'   Calcola l' ArcoSeno di x con -1 <= x <= 1.
'   Asin e' in radianti.
'
    If (Abs(X) < 1#) Then
        Asin = Atn(X / Sqr(1# - X * X))
'
    ElseIf (X = 1#) Then
        Asin = PI / 2#
'
    ElseIf (X = -1#) Then
        Asin = -PI / 2#
'
    Else
        Err.Raise 5, "Asin Function", "Argomento illegale per Asin"
    End If
'
'
'
End Function
Public Function RandN(ByVal VMedio As Single, ByVal Sigma As Single) As Single
'
'   Ritorna una variabile casuale reale a distribuzione normale:
'
    Dim E!, I&
'
    E = 0!
    For I = 1 To 12
        E = E + Rnd
    Next I
'
    RandN = VMedio + Sigma * (E - 6!)
'
'
'
End Function
Public Function RandR(ByVal Sigma As Single) As Single
'
'   Ritorna una variabile casuale reale a distribuzione di Rayleigh:
'
    RandR = Sqr(-2! * Sigma * Sigma * Log(1! - Rnd))
'
'
'
End Function
Public Function RandU(ByVal V_Min As Single, ByVal V_Max As Single) As Single
'
'   Ritorna una variabile casuale reale a distribuzione uniforme:
'
    RandU = V_Min + (V_Max - V_Min) * Rnd
'
'
'
End Function

Public Function KAscVetC(ByVal KA As Integer, VetC$(), Optional ByVal ChrAdd$ = "0")
'
'   Ritorna solo i caratteri contenuti nel vettore VetC$()
'   ed i caratteri di controllo.
'   Questa versione permette di passare il carattere
'   addizionale ChrAdd$ da ritornare come valido.
'   Tutti gli altri caratteri vengono annullati.
'   Va' usato nella procedura KeyPress di TextB come:
'   KeyAscii = KAscVetC(KeyAscii , VetC$(), [ChrAdd$])
'
    Dim I&, KeyAdd%
    Dim TextB As TextBox    ' Solo per TextBoxes.
    'Dim TextB As Control    ' Anche per Combo, etc...
'
    KeyAdd = Asc(ChrAdd$)
'
    Set TextB = Screen.ActiveControl
'
    For I = LBound(VetC$) To UBound(VetC$)
        If (KA = Asc(VetC$(I))) Then
            KAscVetC = KA
            Exit Function
        End If
    Next I
'
    Select Case KA
        Case vbKeyBack, KeyAdd
        KAscVetC = KA
'
        Case Else
        KAscVetC = 0
    End Select
'
'
'
End Function
Public Function KAscHexVal(ByVal KA As Integer, _
    Optional ByVal NEG As Boolean = False, _
    Optional ByVal ChrAdd$ = "0")
'
'   Ritorna solo i caratteri validi per un campo
'   contenente un numero intero in notazione esa-
'   decimale (anche negativo se viene passato il
'   valore Neg = True).
'   Questa versione permette di passare il carattere
'   addizionale ChrAdd$ da ritornare come valido.
'   Tutti gli altri caratteri vengono annullati.
'   Va' usato nella procedura KeyPress di TextB come:
'   KeyAscii = KAscHexVal(KeyAscii [, Neg])
'
    Dim KeyMinus%, KeyAdd%
    Dim TextB As TextBox    ' Solo per TextBoxes.
    'Dim TextB As Control    ' Anche per Combo, etc...
'
    Const myKeyMinus% = 45  ' E' il valore effettivamente ritornato
                            ' alla pressione del tasto - ;
                            ' vbKeySubtract (= 109) non funziona.
    KeyAdd = Asc(ChrAdd$)
'
    Set TextB = Screen.ActiveControl
'
    ' Filtro per il segno "-":
    If (Left$(TextB.Text, 1) <> "-" Or TextB.SelText = TextB.Text) _
    And NEG And TextB.SelStart = 0 Then KeyMinus = myKeyMinus
'
    Select Case KA
        Case vbKey0 To vbKey9, vbKeyA To vbKeyF, KeyMinus, vbKeyBack, KeyAdd
        KAscHexVal = KA
'
        Case Else
        KAscHexVal = 0
    End Select
'
'
'
End Function
Public Function KAscNumInteri(ByVal KA As Integer, _
    Optional ByVal NEG As Boolean = False) As Integer
'
'   Ritorna solo i caratteri validi per un campo
'   contenente un numero intero (anche negativo se
'   viene passato il valore Neg = True).
'   Tutti gli altri caratteri vengono annullati.
'   Va' usato nella procedura KeyPress di TextB come:
'   KeyAscii = KAscNumInteri(KeyAscii [, Neg])
'
    Dim KeyMinus%
    Dim TextB As TextBox    ' Solo per TextBoxes.
    'Dim TextB As Control    ' Anche per Combo, etc...
'
    Const myKeyMinus% = 45  ' E' il valore effettivamente ritornato
                            ' alla pressione del tasto - ;
                            ' vbKeySubtract (= 109) non funziona.
'
    Set TextB = Screen.ActiveControl
'
    ' Filtro per il segno "-":
    If (Left$(TextB.Text, 1) <> "-" Or TextB.SelText = TextB.Text) _
    And NEG And TextB.SelStart = 0 Then KeyMinus = myKeyMinus
'
    Select Case KA
        Case vbKey0 To vbKey9, KeyMinus, vbKeyBack
        KAscNumInteri = KA
'
        Case Else
        KAscNumInteri = 0
    End Select
'
'
'
End Function
Public Function Ceil(ByVal X As Double) As Double
'
'   Funzione di arrotondamento, per numeri reali,
'   all' intero uguale o immediatamente superiore:
'
    If (X = Int(X)) Then
        Ceil = X
    Else
        Ceil = Int(X) + 1#
    End If
'
'
'
End Function
Public Function IsLoaded(ByVal frmF As Form) As Boolean
'
'   Ritorna True se il Form frmF e' gia' caricato in memoria:
'
    Dim I&
'
    For I = 0 To Forms.Count - 1
        If (Forms(I) Is frmF) Then
            IsLoaded = True
            Exit Function
        End If
    Next I
'
    IsLoaded = False
'
'
'
End Function
Public Function BreakDown(ByVal Full$, Optional ByRef Pname$, _
    Optional ByRef FName$, Optional ByRef Ext$) As Boolean
'
'   Scompone un nome di File completo di Path nelle sue parti:
'   Full$  = Nome completo del File.
'   PName$ = Path del File (con \ finale).
'   FName$ = Nome del File con Estensione.
'   Ext$   = .Estensione del File.
'
'   Se il File non esiste scompone il nome e ritorna False.
'
    Dim Sloc&, Dot&
'
    BreakDown = FileExists(Full$)
'
    If InStr(Full$, "\") Then
        FName$ = Full$
        Pname$ = ""
        Sloc = InStr(FName$, "\")
        Do While Sloc <> 0
            Pname$ = Pname$ & Left$(FName$, Sloc)
            FName$ = Mid$(FName$, Sloc + 1)
            Sloc = InStr(FName$, "\")
        Loop
    Else
        Pname$ = ""
        FName$ = Full$
    End If
'
    Dot = InStr(Full$, ".")
    If (Dot <> 0) Then
        Ext$ = Mid$(Full$, Dot)
    Else
        Ext$ = ""
    End If
'
'
'
End Function
Public Function FileExists(ByVal FileN$) As Boolean
'
'   Verifica l' esistenza del file FileN$:
'
    Dim lRet&
'
    On Error Resume Next
'
    lRet = FileLen(FileN$)
    FileExists = (Err = 0)
    Err.Clear
'
'
'
End Function
Public Sub Swap(vN1 As Variant, vN2 As Variant)
'
'
    Dim vTn As Variant
'
    vTn = vN1
    vN1 = vN2
    vN2 = vTn
'
'
'
End Sub
Public Sub Stat_F(ByVal FileN$, _
    Optional ByRef dVMin As Double, Optional ByRef dVMax As Double, _
    Optional ByRef dVMedio As Double, Optional ByRef dDevStd As Double, _
    Optional ByRef lNVal As Long, Optional ByRef dSVal As Double)
'
'   Calcola alcuni valori statistici dei
'   dati contenuti nel file FileN$:
'
    Dim FF%, dVal#, dSValQ#, M$
'
    On Error GoTo Stat_F_ERR
'
    FF = FreeFile
    Open FileN$ For Input As #FF
'
    On Error GoTo Stat_F_ERR
'
    dVMin = 1E+300
    dVMax = -1E+300
    lNVal = 0
    dSVal = 0#
'
    Do While Not EOF(FF)
        Input #FF, dVal
        lNVal = lNVal + 1
        If (dVal < dVMin) Then dVMin = dVal
        If (dVMax < dVal) Then dVMax = dVal
        dSVal = dSVal + dVal
        dSValQ = dSValQ + dVal * dVal
    Loop
'
    dVMedio = dSVal / CDbl(lNVal)
    dDevStd = CDbl(lNVal) * dSValQ - dSVal * dSVal
    dDevStd = Sqr(dDevStd / (CDbl(lNVal) * (CDbl(lNVal - 1))))
'
'
Stat_F_ERR:
    Close #FF
    If (Err.Number <> 0) Then
        M$ = Err.Number & "  " & Err.Description & vbNewLine
        If lNVal < 2 Then M$ = M$ & "Il File dei dati contiene meno di 2 valori."
        MsgBox M$, vbCritical, " modUtilita: Stat_F"
    End If
'
'
'
End Sub
Public Function ContainerEnabled(ByVal ctrContainer As Control, _
    ByVal bEnabled As Boolean) As Boolean
'
'   Abilita o disabilita ctrContainer e
'   tutti i controlli al suo interno.
'   La routine e' ricorsiva.
'
    Dim Control As Control, ControlC As Control
'
    On Error Resume Next    ' Gestisce i controlli senza proprieta' .Enabled
                            ' e quelli senza proprieta' .Container.
'
    ctrContainer.Enabled = bEnabled
    DoEvents
'
    For Each Control In ctrContainer.Parent.Controls
        If (Control.Container Is ctrContainer) Then
            If (TypeOf Control Is Frame) _
            Or (TypeOf Control Is PictureBox) Then
                ContainerEnabled Control, bEnabled
            Else
                If (Err.Number = 0) Then Control.Enabled = bEnabled
                Err.Clear
            End If
        End If
    Next Control
'
    ContainerEnabled = (Err.Number = 0)
'
'
'
End Function
Public Sub Stat_V(dVal() As Double, _
    Optional ByRef dVMin As Double, Optional ByRef dVMax As Double, _
    Optional ByRef dVMedio As Double, Optional ByRef dDevStd As Double, _
    Optional ByRef lNVal As Long, Optional ByRef dSVal As Double)
'
'   Calcola alcuni valori statistici dei
'   dati contenuti nel vettore dVal():
'
    Dim I&, dSValQ#, M$
'
    On Error GoTo Stat_V_ERR
'
    lNVal = UBound(dVal) - LBound(dVal) + 1
    If (lNVal < 2) Then Err.Raise 5
'
    dVMin = dVal(LBound(dVal))
    dVMax = dVal(LBound(dVal))
    dSVal = dVMin
    dSValQ = dVMin * dVMin
'
    For I = LBound(dVal) + 1 To UBound(dVal)
        If (dVal(I) < dVMin) Then dVMin = dVal(I)
        If (dVMax < dVal(I)) Then dVMax = dVal(I)
        dSVal = dSVal + dVal(I)
        dSValQ = dSValQ + dVal(I) * dVal(I)
    Next I
'
    dVMedio = dSVal / CDbl(lNVal)
    dDevStd = CDbl(lNVal) * dSValQ - dSVal * dSVal
    dDevStd = Sqr(dDevStd / (CDbl(lNVal) * (CDbl(lNVal - 1))))
'
'
Stat_V_ERR:
    If (Err.Number <> 0) Then
        M$ = Err.Number & "  " & Err.Description & vbNewLine
        If (lNVal < 2) Then M$ = M$ & "Il vettore dei dati contiene meno di 2 valori."
        MsgBox M$, vbCritical, " modUtilita: Stat_V"
    End If
'
'
'
End Sub
Public Function DMAXVAL(dVet() As Double) As Double
'
'   Ritorna il valore massimo contenuto nel vettore dVet().
'   Implementa l' equivalente funzione del FORTRAN.
'
    Dim J&, J1&, J2&, dDMax#
'
    J1 = LBound(dVet)
    J2 = UBound(dVet)
    dDMax = dVet(J1)
    For J = J1 + 1 To J2
        If (dDMax < dVet(J)) Then dDMax = dVet(J)
    Next J
'
    DMAXVAL = dDMax
'
'
'
End Function
Public Function DMINVAL(dVet() As Double) As Double
'
'   Ritorna il valore minimo contenuto nel vettore dVet().
'   Implementa l' equivalente funzione del FORTRAN.
'
    Dim J&, J1&, J2&, dDMin#
'
    J1 = LBound(dVet)
    J2 = UBound(dVet)
    dDMin = dVet(J1)
    For J = J1 + 1 To J2
        If (dVet(J) < dDMin) Then dDMin = dVet(J)
    Next J
'
    DMINVAL = dDMin
'
'
'
End Function
